package Headlines::News;
use Headlines;
@ISA=("Headlines");
use HTML::Parser;
use HTML::TreeBuilder;
sub parse {
  my $self=shift;
#  print STDERR "Retrieving Document\n";
  my $doc = $self->retrieve;
#  print STDERR "Document Retrieved\n";
  my %result = ();
  my $result = [];
  my $h = new HTML::TreeBuilder;
  $h->parse($doc);
  for $i (@{ $h->extract_links(qw(a))}) {
    my ($link, $linkelem)= @$i;
    my $k;
    my $content="";
    if ($link =~ m,(/News/Item/|/SpecialFeatures/),) {
      foreach $k (@{$linkelem->content}){
#	print "Found Content\n";
#	print $k unless (ref($k));
	$content .=  $k unless ((ref($k)) or ($k =~ /<img/));
	if (ref($k)){
	  if ($k->as_HTML =~ /<IMG/i) {
	    $content .= $k->attr('alt');
	  } else {
	    $content .= $k->as_HTML;
	  }
	}elsif ($k =~ /<img/) {
	  $k =~ /<img(.*?>)/;
	  my $stuff =$1;
	  if ($stuff =~ /alt=\"(.*?)\">/) {
	    $content .=$1;
	  } elsif ($stuff =~ /alt="(.*?)"/) {
	    $content .=$1;
	  }
	}
      }
      if ( $link =~ m~javascript:(openWindowDtn|openwin).\s*.([^\'\"]+).\s*,~i){
	$link = $3;
      }
      if ($link =~ m,^/,) {
	$link = "http://www.news.com" . $link;
      }
      
      unless (($link =~ /^mailto:/) || (length($link) < 5)){
	$result{$link} = $content if ($content=~ /\w+/);
#	push @$result, [ $content,$link] ;
      }
    }
  }
  map { push @$result, [$result{$_}, $_] } keys %result;
  return $result;
}
1;
