#!/usr/bin/perl

package main;
use Headlines;
use Headlines::Ultra;
use Headlines::News;
use Headlines::Zdnet;
use Headlines::Generic;
use Headlines::Yahoo;
use Headlines::Drudge;

my @hls = ();
	   

push @hls,Headlines::Ultra->new(	    'slashdot','http://slashdot.org/ultramode.txt');
push @hls, Headlines::News->new(  'news.com' , 'http://www.news.com/');
push @hls,Headlines::Zdnet->new(  'ZDNet' , 'http://www.zdnet.com/zdnn/?chkpt=hpqs014');

my  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =  localtime(time);
$mon++;
if ($mon < 10) {
  $mon = "0" . $mon;
}

#print $year, $mon,"\n";
my $the_register_regexp = "$year$mon" . '\d+-\d+.html';
my $kurz_reg = "$year$mon\\d{2,2}/3/";
push @hls,Headlines::Generic->new(  'The Register' , 'http://www.theregister.co.uk/reg-index.html',$the_register_regexp);
push @hls,Headlines::Yahoo->new(  'Yahoo Top Stories' , 'http://dailynews.yahoo.com/h/ts/',"http://dailynews.yahoo.com/h/nm/");
push @hls,Headlines::Yahoo->new(  'Yahoo Business' , 'http://dailynews.yahoo.com/h/bs/',"http://dailynews.yahoo.com/h/nm/");
push @hls,Headlines::Yahoo->new(  'Yahoo Tech' , 'http://dailynews.yahoo.com/h/tc/',"http://dailynews.yahoo.com/h/nm/");
push @hls,Headlines::Yahoo->new(  'Yahoo Health' , 'http://dailynews.yahoo.com/h/hl/',"http://dailynews.yahoo.com/h/nm/");
push @hls,Headlines::Yahoo->new(  'Yahoo Kurzberichte' , 'http://de.news.yahoo.com/3/', $kurz_reg);#kurzberichte/\d+.html');
push @hls,Headlines::Ultra->new(	    'mattshouse' , 'http://www.mattshouse.com/ultramode.txt');
#push @hls,Headlines::ultra->new(	    'segfault', 'http://segfault.org/stories.txt');
#push @hls,Headlines::Drudge->new(	    'Drudge Report', 'http://www.drudgereport.com/');
my $drudge=Headlines::Drudge->new(	    'Drudge Report', 'http://www.drudgereport.com/');



open (OUT,">/web/area/docs/fredf/headlines1.html");
# Create a request
$,="\t";$\="\n";
#print OUT <<ZZZ
#<p align="left"><a href="http://www.megadev.com"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>News </b></font></a></p>
#ZZZ
#;
# print "Getting slashdot...\n";
# &print_it (OUT,$slashdot,10);
# print "Getting news dot com...\n";
# &print_it (OUT,$news_dot_com,5);
# print "Getting zdnet...\n";
# &print_it (OUT,$zdnet,5);
print OUT <<ZZZ
  <html>
<head>
<meta http-equiv=Refresh content=900>
<title> Headline Grabber!</title>
</head>

<body background='http://www.netscape.com/assist/net_sites/bg/rock/yellow_rock.gif'>

<!--<img src='headline_grabber.gif'>-->
  <h3> Headlines from all over the world! </h3>
<i>updated every 30 minutes </i>
<p>
The source of the program is available <a href="Headlines-0.5.tar.gz">here</a>
  </P>
  <p>
  If you are interested in any new features or have any feedback whatsoever, please contact the author, <a href="Headlines.pm\@netfinances.com">Fred </a>.
</P>
<table width=100% border>
<tr><td valign='top' align='center'>
ZZZ
;
&print_it(OUT,$drudge,300);
print OUT <<ZZZ
  </td></tr></table>
<TABLE border ><tr>
  
ZZZ
  ;
for (my $i=0;$i<= $#hls;$i++) {
  $perc = $i  / $#hls ;
  $perc *=10;
  $perc =~ s/\..*//;
  print OUT "</Td>" if (( $perc % 3) == 0);
  print OUT "<td valign='top'><!-- $perc -->" if (( $perc % 3) == 0);
  print OUT "<HR>" unless(( $perc % 3) == 0);
  &print_it(OUT,$hls[$i],300);


}
print OUT "</tr></TABLE>";
#map { &print_it(OUT, $_,300)  } @hls;
print OUT <<ZZZ

  </P></body></html>
ZZZ
;
system "cp /web/area/docs/fredf/headlines1.html /web/netfinances/docs/index.html";
system "mv /web/area/docs/fredf/headlines1.html /web/area/docs/fredf/headlines.html";
sub print_it {
  my $handle = shift;
  my $headline = shift;
  my $num = shift;
  my  $i = $headline->caption;
  my $caption= <<ZZZ
<p align="left">   <font size="-1" face="Verdana, Arial, Helvetica, sans-serif"><b><u>$i <br>
  </u></b></font><font size="1" face="Verdana, Arial, Helvetica, sans-serif">
ZZZ
;
  $caption =~ tr [a-z] [A-Z];
  print $handle $caption;
  my $result= $headline->parse;
  my $m = 0;
  foreach $j (@$result ) {
    if ($m++ < $num) {
      my ($headline,$url) = @$j;
      print $handle "<a href='$url'>$headline</a><br><br>";
    }
  }
  print $handle "</font></p>";
}
