#########################################################
#														#
# 			 N O  F R E E  S U P P O R T  !!			#
#														#
#########################################################

#########################################################
#		F R E E  S O F T W A R E  L I C E N S E   		#
#########################################################
#														#
# This PayPal Tools & Interfaces Software 				#
# is Copyright(C) of David W. Van Abel, 2003.			#
#														#
# This program is free software; you can redistribute 	#
# it and/or modify it under the terms of the GNU 		#
# General Public License as published by the Free 		#
# Software Foundation; either version 2 of the License, #
# or (at your option) any later version.				#
#														#
# This program is distributed in the hope that it will 	#
# be useful, but WITHOUT ANY WARRANTY; without even the #
# implied warranty of 									#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  #
# See the GNU General Public License for more details.	#
#														#
# You should have received a copy of the GNU General 	#
# Public License along with this program; if not, write #
# to the Free Software Foundation, Inc., 59 Temple 		#
# Place, Suite 330, Boston, MA  02111-1307  USA			#
# FULL LICENSE IS FOUND AT 								#
# http://opensource.org/licenses/index.html				#
#														#
# David W. Van Abel	- Author							#
# 2131 S. Allison Court									#
# Lakewood, CO USA 80227								#
# 303-249-3855 (V)										#
# dave@vanabel.com										#
# http://vanabel.com									#
# http://perlsources.com								#
# http://ipnhosting.com									#													#
#														#
#########################################################
# 				E N D  O F  L I C E N S E				#
#########################################################

# Filename 	= Ipnx_Config.pl
# Version 	= 1.00
# Date		= 02-14-03

# VARIABLE SETTING & DEFINITIONS #

# $root_dir
# ---------
# Actual directory script will run from
# Start path with leading slash & never end with a slash

$root_dir = "/usr/local/vhosts/perlsources/cgi-bin/ipnx";

# $write_data_files
# -----------------
# Write data files, set to 1
# DO NOT write data files, set to 0

$write_data_files = 1;

# $data_root_dir
# --------------
# Parent directory for data files (data & history)
# If located under $root_dir, set = $root_dir, 
# else to desired location.
# Please note, these directories REQUIRE read-write 
# for the WEB SERVER. If you encounter errors saving files,
# check this condition
# These files can be under cgi-bin or htdocs areas

$data_root_dir = "/usr/local/vhosts/perlsources/cgi-bin/ipnx";

# $data_dir
# ---------
# Directory for data files, under the $root_dir

$data_dir = "data";

# $history_dir
# ------------
# Directory for history files, under the $root_dir

$history_dir = "history";

# $logfile_dir
# ------------
# Directory for log files, under the $root_dir
# If you move data & history to htdocs, also move this 
# directory to the same area.

$logfile_dir = "logs";

# $data_file_end
# --------------
# Ending extension for data & history files
# Make sure it has a dot in front of it

$data_file_end	= ".txt";

# $email_admin
# ------------
# Email address of application admin
# Leave in single quotes to avoid problem with @ sign

$email_admin	= 'dave@vanabel.com';

# $print_admin_detail
# -------------------
# To print order detail in admin email, set this value
# to "1", else set to "0" to ignore printing it.

$print_admin_detail = 1;

# $mail_program
# -------------
# Location of sendmail

$mail_program 	= "/usr/sbin/sendmail -t ";

# $do_mail
# --------
# 1 => Send Email, 0 => Do not send email
# FOR TESTING PURPOSES, YOU MAY ELECT TO TURN EMAIL NOTICES
# ON or OFF. IN THIS CASE, SEE VARIABLE $do_mail= 1
# BELOW (IT HAS INSTRUCTIONS ON THE LINE.

$do_mail= 1;

# $domain
# -------
# Domain or business name related to this application
# This value is used in the next line

$domain	= "perlsources.com";

# $email_subject
# --------------
# Standard Email subject

$email_subject = "Sales Receipt Email from - $domain";

# End of standard applications Configuration File #


