#!/usr/bin/perl
#######################################################
#		Home Free v3.24n (Nearly Null)
#     
#    	Created by Solution Scripts
# 		Email: solutions@solutionscripts.com
#		Web: http://solutionscripts.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Solution Scripts  All Rights Reserved.
#
# Selling or redistributing the code for this program 
# without prior written consent is expressly forbidden. 
# In all cases copyright and header must remain intact.
#
#######################################################

$|=1;

require "variables.pl";
require "acc_auth.pl";
require "dblib.pl";
require "header_footer.pl";

print "Content-type: text/html\n\n ";

&Account::initialize;

&Account::verify_user;

if ($INPUT{'ftp_import'}) { &ftp_import; }
elsif ($INPUT{'action'} eq "ftp") { &ftp; }
elsif ($INPUT{'new'}) { &new; }

####################  
sub ftp {
	
my $message = $_[0];
if ($message) { $message .="<BR><BR>"; }

&Account::header("$lang::ft1");
	
$html = &Account::dir_select_list($INPUT{'dir'});

opendir (DIR, "$ftp_path/$Account::account");
@files = grep {!(/^\./)}  readdir(DIR);
close (DIR); 

print <<EOF;
<FORM METHOD=POST ACTION="$cgiurl" name="ftp">
$Account::hidden_variables
<font face=$font_face size=$font_size><B>
$message
$lang::ft2</B><BR><BR>
<table cellpadding=5 border=1 cellspacing=0 bgcolor=$table_bg>
<TR><TD bgcolor=$table_head_bg align=center colspan=5> 
<font color=$text_table_head face=$font_face size=$font_size>$lang::ft3
<SELECT name="dir">
$html
</SELECT>
</TD></TR>
<TR bgcolor=$table_head_bg>
<TD align=center><font color=$text_table_head face=$font_face size=$font_size>$lang::um10</FONT></TD>
<TD align=center><font color=$text_table_head face=$font_face size=$font_size>$lang::um19</FONT></TD>
<TD align=center><font color=$text_table_head face=$font_face size=$font_size>$lang::um11</FONT></TD>
<TD align=center><font color=$text_table_head face=$font_face size=$font_size>$lang::um13</FONT></TD>
<TD align=center><font color=$text_table_head face=$font_face size=$font_size>$lang::ft4</FONT></TD>
</TR>
EOF

@filess = sort (@files);

unless(@filess) {
print <<EOF;
<TR><TD colspan=6 align=center><BR><font face=$font_face size=$font_size>$lang::ft5</FONT><BR><BR></TD></TR>
EOF
}

foreach $file(@filess) {
	next if $bad_files{$file};
	@stats = stat("$ftp_path/$Account::account/$file");
	$mtime = $stats[9];
	($msec,$mmin,$mhour,$mmday,$mmon,$myear,$mwday,$myday,$misdst) = localtime($mtime);
	$mmonth = $months[$mmon];
	$myear += 1900;


	$size = $stats[7];
	$size = $size /1000;
	if (($file =~ /\.gif$/i) || ($file =~ /\.jpg$/i) || ($file =~ /\.jpeg$/i)) {
		$image = "image";
	} 
	elsif(($file =~ /\.html$/i) || ($file =~ /\.htm$/i) || ($file =~ /\.shtml$/i)) {
		$image="text";
	}
	elsif(($file =~ /\.zip$/i) || ($file =~ /\.tar$/i)) {
		$image="compressed";
	}
	elsif(($file =~ /\.wav$/i) || ($file =~ /\.avi$/i)) {		
		$image="sound";
	}
	else {
		$image = "unknown";
	}

print <<EOF;
<TR><TD align=center><font face=$font_face size=$font_size><INPUT TYPE="CHECKBOX" NAME="ftp_$file" VALUE="checked"></FONT></TD>
<TD align=center><font face=$font_face size=$font_size></FONT><IMG SRC="$url_to_icons/$image.gif"></TD>
<TD><font face=$font_face size=$font_size>$file</FONT></TD>
<TD><font face=$font_face size=$font_size>$size K</FONT></TD>
<TD><font face=$font_face size=$font_size>$mmonth $mmday, $myear $mhour:$mmin</FONT></TD></TR>
EOF
}

print <<EOF;
<TR><TD bgcolor=$table_head_bg align=center colspan=5> 
<font color=$text_table_head face=$font_face size=$font_size>
$lang::ft6 <input name="allbox" type="checkbox" value="Check All" onClick="CheckAll();">
&nbsp;&nbsp;&nbsp;
<input type="Submit" name="ftp_import" value="$lang::ft7">
</TD></TR></TABLE></FORM>
<SCRIPT>
<!--
function CheckAll() {
	for (var i=0;i<document.ftp.elements.length;i++) {
	    var e = document.ftp.elements[i];
	    if (document.ftp.elements[i].name != 'allbox') {
			e.checked = document.ftp.allbox.checked;

    	}
  	}
}
//-->
</SCRIPT>
EOF

&Account::footer;
exit;
}

########## FTP IMPORT ##########
sub ftp_import {

opendir (DIR, "$ftp_path/$Account::account") || &error("can not open $ftp_path/$account");
@files = grep {!(/^\./)}  readdir(DIR);
close (DIR); 

$res ='';
foreach $file(@files) {
	unless ($INPUT{'ftp_' . $file}) { next; }
		
	@filename=split(/\./,$file);
	$ext = "." . $filename[1];
	$ext ="\L$ext\E";
	$base_name = $filename[0];
	@out = split(//,$base_name);
	foreach $char (@out) {
		unless (($char =~ /[a-z]/) || ($char =~ /[A-Z]/) || ($char =~ /[0-9]/) || ($char =~ /_/)){
			$res .= "$file $lang::ft8<BR>"; # not imported -- Invalid File name
			last;
		}
	}
	if ($res =~ /$file/) { next; }
	unless ($ext && ($good_types{$ext})) {
		$res .= "$file $lang::ft9<BR>"; # not imported -- $ext -- Invalid file type
		unlink ("$ftp_path/$Account::account/$file");
		next
	}	
	if ($res =~ /$file/) { next; }
		
	$start_body =0;
	$end_body = 0;

	$"='';

	undef $/;
	open (HEAD, "$ftp_path/$Account::account/$file");
	$content = <HEAD>;
	close (HEAD);
	
	if ($good_types{$ext} eq "html") { 
		$content = &headers::remove($content);
		$new_content = &headers::add($content,$head,$foot);
	}
	else {
		$new_content = $content;
	}	
		
	@stats = stat("$ftp_path/$Account::account/$file");
	$mtime = $stats[9];
	($msec,$mmin,$mhour,$mmday,$mmon,$myear,$mwday,$myday,$misdst) = localtime($mtime);
	$mmonth = $months[$mmon];
	$myear += 1900;

	$gsize = $stats[7];
	$gsize = $gsize /1000;
	$t_size = $gsize + $Account::size;
	$total_size += $Account::size_added;

	if ($t_size > $total_size) {
		$res .= "$file $lang::uu6 - $t_size - $total_size<BR>";
		next;
	}

	open (DAT,">$dir_plus/$file");
	print DAT "$new_content";
	close (DAT);

	unlink ("$ftp_path/$Account::account/$file");
	$res .="$file $lang::ft10<BR>";	
	$/="\n";
}	

&Account::space_file_check;
&Account::print_account;

&ftp($res);
	
}
1;



