<?php
//
// AudiStat v1.0 by Alexandre Dubus
// February 2003
//
// Parameters :
// year=YYYY
// month=MM
// mday=dd

require("config.php");
require("month.php");
require("tld.php");

function db_open () {
	global $link;
	global $sql_host, $sql_login,$sql_passe,$sql_dbase;
	$link = mysql_connect($sql_host, $sql_login,$sql_passe)
	        or die ("Can't connect to $sql_host: $!\n");
	mysql_select_db ($sql_dbase)
	        or die ("Can't select database $sql_dbase: $!\n");
}
	
function db_close () {
	global $link;
	mysql_close($link);
}

function db_query_daystats($month,$year) {
	global $sql_table;
	global $m_name;

	$day_stat         = array();
	$day_stat_percent = array();
	$total            = 0;
	$max_percent      = 1;
	$max              = 0;

	$query = "SELECT DAYOFMONTH(time_str), COUNT(*) FROM $sql_table WHERE MONTH(time_str) = $month AND YEAR(time_str) = $year GROUP BY 1 ORDER BY 1";
	$result = mysql_query($query);
	if (!$result) {
		echo "<!-- query $query failed : " . mysql_error() . " -->\n";
		return ;
	}

	while (list($day,$count) = mysql_fetch_row($result)) {
		$day_stat[$day] = $count;
		$total += $count;
		if ($max<$count) $max=$count;
	}

	reset ($day_stat);
	while (list($day,$count) = each($day_stat)) {
		$day_stat_percent [$day] = sprintf("%3.2f",$count * 100 / $total);
		if ($max_percent < $day_stat_percent[$day]) {
			$max_percent = $day_stat_percent[$day];
		}
	}
?>
<P>
<TABLE class="Table1" cellSpacing=1>
 <TR class="TR1">
  <TH colspan="2">Stats per day -- <?= $m_name[$month] ?> <?= $year ?></TH></TR>
 <TR class="TR2">
  <TD class="TD10" rowspan="2"><?= $max ?> --</TD>
  <TD class="TD11">&nbsp;
   <TABLE>
    <TR>
<?php
	reset($day_stat);
	while (list($day,$count) = each($day_stat)) {
?>
     <TD class="TD1">
      <IMG src="bleu.png" width="15" height="<?= 100 * $day_stat_percent[$day] / $max_percent ?>"></TD>
<?php
	}
?>
    </TR></TABLE></TD></TR>
 <TR class="TR3">
  <TD class="TD11">
   <TABLE>
    <TR>
<?php
	reset($day_stat);
	while (list($day,$count) = each($day_stat)) {
?>
     <TD class="TD1"><?= $day ?></TD>
<?php
	}
?>
    </TR></TABLE></TD></TR></TABLE>
<?php
}

function db_query_hourstats($querystring) {
	global $sql_table;
	$hour_stats   = array();

	$query = "SELECT HOUR(time_str), COUNT(*) FROM $sql_table WHERE $querystring GROUP BY 1";
	$result = mysql_query($query);
	if (!$result) {
		echo "<!-- query $query failed : " . mysql_error() . " -->\n";
		return ;
	}
	for ($hour=0;$hour<24;$hour++) $hour_stats[$hour]=0;
	$max=0;
	while (list($hour,$count) = mysql_fetch_row($result)) {
		if ($count>$max) $max = $count;
		$hour_stats[$hour] = $count;
	}
?>
<P>
<TABLE class="Table1" cellSpacing=1>
 <TR class="TR1">
  <TH colspan="2">Stats per hour</TH></TR>
 <TR class="TR2">
  <TD class="TD10" rowspan="2"><?= $max ?>--</TD>
  <TD class="TD11">&nbsp;
   <TABLE>
    <TR>
<?php
	for ($hour=0;$hour<24;$hour++) {
?>
     <TD class="TD1">
      <IMG src="bleu.png" width="15" height="<?= 100 * $hour_stats[$hour] / $max ?>"></TD>
<?php
	}
?>
    </TR></TABLE></TD></TR>
 <TR class="TR3">
  <TD class="TD11">
   <TABLE>
    <TR>
<?php
	for ($hour=0;$hour<24;$hour++) {
?>
     <TD class="TD1"><?= $hour ?></TD>
<?php
	}
?>
    </TR></TABLE></TD></TR></TABLE>
<?php
}

function db_query_lastsites($querystring) {
	global $sql_table;

	$query = "SELECT remote_host,MAX(time_str) FROM $sql_table WHERE $querystring GROUP BY 1 ORDER BY 2 DESC LIMIT 15";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return ;}

?>
<P>
<TABLE class="Table1" cellSpacing=1>
 <TR class="TR1">
  <TH colspan="3">Last Sites</TH></TR>
 <TR class="TR1">
  <TH class="TD6">#</TH>
  <TH class="TD5">Date</TH>
  <TH>Hostname</TH></TR>
<?php
	$idx=1;
	while (list($site,$date) = mysql_fetch_row($result)) {
?>
 <TR class="TR2">
  <TD class="TD4"><?= $idx ?> 
   <IMG src="closed.gif" id="c<?=$idx?>" class="Outline" width="12" height="12" onclick="clickHandler('c<?=$idx?>')" style="CURSOR: hand"></TD>
  <TD class="TD2"><?= $date ?></TD>
  <TD class="TD2"><?= $site ?></TD></TR>
 <TBODY div id=dc<?=$idx?> style="Display:none">
<?php
		$q2 = "SELECT request,time_str FROM $sql_table WHERE $querystring AND remote_host=\"$site\" ORDER BY 2 DESC LIMIT 15";
		$r2 = mysql_query($q2);
		if (!$r2) {
			echo "<!-- query $q2 failed : " . mysql_error() . " -->\n";
			return ;
		}
		while (list($req,$date) = mysql_fetch_row($r2)) {
?>
 <TR class="TR3">
  <TD class="TD4">.</TD>
  <TD class="TD3"><?= $date ?></TD>
  <TD class="TD2"><A href="<?= $req ?>"><?= $req ?></A></TD></TR>
<?php			
		}
?>
 </TBODY>
<?php
		$idx++;
	}
?>
</TABLE>
<?php
}

function table_head($tablename) {
?>
<P>
<TABLE class="Table1" cellSpacing=1>
 <TR class="TR1">
  <TH colspan="4">Top <?= $tablename ?></TH></TR>
 <TR class="TR1">
  <TH class="TD6">#</TH>
  <TH class="TD7" colspan="2">Hits</TH>
  <TH class="TD8"><?= $tablename ?></TH></TR>
<?php
}

function table_obj($obj_stat,$total,$link) {
	reset ($obj_stat);
	while (list($idx,$val) = each ($obj_stat)) {
		$obj     = $obj_stat[$idx]['obj'];
		$count   = $obj_stat[$idx]['count'];
		$percent = sprintf("%3.2f",$count * 100 / $total);
?>
 <TR class="TR2">
  <TD class="TD4"><?= $idx ?></TD>
  <TD class="TD3"><?= $count ?></TD>
  <TD class="TD2"><IMG src="bleu.png" width="<?= 100 * $count/$total ?>" height="8"><?= $percent ?>%</TD>
<?php
		if ($link == 1) {
?>
  <TD class="TD2"><A href="<?= $obj ?>"><?= $obj ?></A></TD></TR>
<?php
		} else {
?>
  <TD class="TD2"><?= $obj ?></TD></TR>
<?php
		}
	}
?>
</TABLE>
<?php
}

function db_query_top($result,$tablename,$link) {
	$url_stat         = array();
	$total            = 0;
	
	$idx = 1;
	while (list($obj,$count) = mysql_fetch_row($result)) {
		$obj_stat [$idx]['obj']   = $obj;
		$obj_stat [$idx]['count'] = $count;
		$total += $count;
		$idx ++;
	}
	table_head($tablename);
	table_obj($obj_stat,$total,$link);return;
}


function db_query_topurls($querystring) {
	global $sql_table;

	$url_stat         = array();
	$total            = 0;

	$query = "SELECT request, COUNT(*) FROM $sql_table WHERE $querystring GROUP BY 1 ORDER BY 2 DESC";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return;}

	db_query_top($result,"URLs",1);
}

function db_query_topsites($querystring) {
	global $sql_table;

	$query = "select remote_host,COUNT(*) from $sql_table WHERE $querystring GROUP BY 1 ORDER BY 2 DESC LIMIT 30";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return ;}

	db_query_top($result,"Site",0);
}

function db_query_toprefs($querystring) {
	global $sql_table;

	$query = "select referer,COUNT(*) from $sql_table WHERE $querystring GROUP BY 1 ORDER BY 2 DESC LIMIT 30";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return ;}

	db_query_top($result,"Referers",1);
}

function db_query_topsearch($querystring) {
	global $sql_table;

	$site_stat         = array();
	$site_stat_percent = array();
	$total             = 0;

	$query = "select referer,COUNT(*) from $sql_table WHERE $querystring AND INSTR(referer,'?q=') GROUP BY 1 ORDER BY 2 DESC LIMIT 30";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return ;}

	$idx = 1;

	while (list($site,$count) = mysql_fetch_row($result)) {
		$url = parse_url($site);
		$query = $url['query'];
		unset ($q);

		$a = explode('&', $query);
		reset ($a);
		while (list($k,$v) = each($a)) {
			$b = split('=',$v);
			$key = htmlspecialchars(urldecode($b[0]));
			$val = htmlspecialchars(urldecode($b[1]));
			if ($key == 'q')
				$q = $val;
		}
		if (isset($q)) {
			$site_stat [$idx]['obj']  = $q;
			$site_stat [$idx]['count'] = $count;
			$total += $count;
			$idx ++;
		}
	}
	table_head("Searchs");
	table_obj($site_stat,$total,0);return;
}

function db_query_topagents($querystring) {
	global $sql_table;

	$query = "SELECT user_agent,COUNT(*) FROM $sql_table WHERE $querystring GROUP BY 1 ORDER BY 2 DESC LIMIT 30";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return ;}
	db_query_top($result,"Agents",0);
}

function db_query_topctrys($querystring) {
	global $sql_table;
	global $g_tld;

	$tld_stat         = array();
	$total            = 0;
	$total_unknown    = 0;

	$query = "SELECT RIGHT(remote_host,INSTR(REVERSE(remote_host),\".\")-1),COUNT(*) FROM $sql_table WHERE $querystring GROUP BY 1 ORDER BY 2 DESC";
	$result = mysql_query($query);
	if (!$result) {echo "<!-- query $query failed : " . mysql_error() . " -->\n";return ;}

	$idx=1;
	while (list($tld, $count) = mysql_fetch_row($result)) {
		$tld_found = $g_tld[$tld];
		if (isset($tld_found)) {
			$tld_stat[$idx]['obj'] = $tld_found;
			$tld_stat[$idx]['count']= $count;
			$idx++;
		} else
			$total_unknown += $count;
		$total += $count;
	}
	if ($total_unknown>0) {
		$tld_stat[$idx]['obj'] = "Unresolved/Unknown";
		$tld_stat[$idx]['count'] = $total_unknown;
	}
	table_head("Countries");
	table_obj($tld_stat,$total,0);
}

function db_query_all_months() {
	global $sql_table;
	global $m_name;

	$query = "SELECT YEAR(time_str),MONTH(time_str),COUNT(*) FROM $sql_table GROUP BY 1,2 ORDER BY 1,2";
	$result = mysql_query($query);
	if (!$result) {
		echo "<!-- query $query failed : " . mysql_error() . " -->\n";
		return ;
	}
?>
<P>
<TABLE class="Table1" cellSpacing=1>
 <TR class="TR1">
  <TH rowspan="2">Period</TH>
  <TH colspan="2">Mean hits per day</TH>
  <TH colspan="2">Total</TH></TR>
 <TR class="TR1">
  <TH>Visits</TH>
  <TH>Hits</TH>
  <TH>Visits</TH>
  <TH>Hits</TH></TR>
<?php
	$total = 0;
	$totalv=0;
	$idx=0;
	while (list($year,$month,$count) = mysql_fetch_row($result)) {
		$idx++;
		$q2 = "SELECT DAYOFMONTH(time_str) FROM $sql_table WHERE YEAR(time_str) = $year AND MONTH(time_str) = $month GROUP BY 1 ORDER BY 1";
		$r2 = mysql_query($q2);
		if (!$r2) {
			echo "<!-- query $q2 failed : " . mysql_error() . " -->\n";
			return ;
		}
		$nday = mysql_num_rows($r2);
		$total += $count;
		
		$q3 = "SELECT remote_host FROM $sql_table WHERE YEAR(time_str) = $year AND MONTH(time_str) = $month GROUP BY 1";
		$r3 = mysql_query($q3);
		if (!$r3) {
			echo "<!-- query $q3 failed : " . mysql_error() . " -->\n";
			return ;
		}
		$nvisit = mysql_num_rows($r3);
		$totalv += $nvisit;		
?>
 <TR class="TR2">
  <TD class="TD9"><A HREF="?year=<?= $year ?>&month=<?= $month ?>"><?= $m_name[$month] ?> <?= $year ?></A>
   <IMG src="closed.gif" id="c<?=$idx?>" class="Outline" width="12" height="12" onclick="clickHandler('c<?=$idx?>')" style="CURSOR: hand"></TD>
  <TD><?= round($nvisit / $nday) ?></TD>
  <TD><?= round($count / $nday) ?></TD>
  <TD><?= $nvisit ?></TD>
  <TD><?= $count ?></TD></TR>
 <TBODY div id="dc<?=$idx?>" style="display:none;">
<?php
		while (list($d,$count) = mysql_fetch_row($r2)) {
			$q4 = "SELECT remote_host FROM $sql_table WHERE YEAR(time_str) = $year AND MONTH(time_str) = $month AND DAYOFMONTH(time_str) = $d GROUP BY 1";
			$r4 = mysql_query($q4);
			if (!$r4) {
				echo "<!-- query $q4 failed : " . mysql_error() . " -->\n";
				return ;
			}
			$nvisit = mysql_num_rows($r4);

			$q5 = "SELECT * FROM $sql_table WHERE YEAR(time_str) = $year AND MONTH(time_str) = $month AND DAYOFMONTH(time_str) = $d";
			$r5 = mysql_query($q5);
			if (!$r5) {
				echo "<!-- query $q5 failed : " . mysql_error() . " -->\n";
				return ;
			}
			$nhit = mysql_num_rows($r5);
		

?>
 <TR class="TR2">
  <TD class="TD9" colspan="3">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="?year=<?= $year ?>&month=<?= $month ?>&mday=<?= $d ?>"><?= $d ?></A><BR></TD>
  <TD><?= $nvisit ?></TD>
  <TD><?= $nhit ?></TD></TR>
<?php
		}
?>
 </TBODY>
<?php
	}
?>
 <TR class="TR3">
  <TD colspan="3"><b>Total</b><BR></TD>
  <TD><?= $totalv ?></TD>
  <TD><?= $total ?></TD></TR></TABLE>
<?php
}

function html_header($month,$year) {
	global $HTTP_HOST;
	global $m_name;
	global $mday;

	$title = "Site statistics -- " . $HTTP_HOST;

	if (isset($month) && isset($year)) {
		$title = $title . " - " . $mday. " " . $m_name[$month] . " " . $year;
	}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
 <HEAD>
  <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <SCRIPT language="JavaScript">
   <!--
   function clickHandler(id) {
    var targetId, srcElement, targetElement;
    var srcElement    = document.getElementById(id);
    var targetElement = document.getElementById("d" + id);
    if (targetElement.style.display == "none") {
     srcElement.src              = "open.gif";
     targetElement.style.display = "";
    } else {
     srcElement.src              = "closed.gif";
     targetElement.style.display = "none";
    }
   }
   //-->
  </SCRIPT>
  <LINK rel="StyleSheet" type="text/css" href="php.css">
   <TITLE><?= $title ?></TITLE>
 </HEAD>
<BODY class="Body">
<CENTER>
<TABLE class="Table1" cellSpacing="1">
    <TR class="TR1">
      <TD><H2><?= $title ?></H2></TD></TR></TABLE>
<HR>
<?php
}

function html_footer() {
	global $m_name;

	// compute the current date
	$today   = getdate();
	$jour    = $today['mday'];
	$mois    = $m_name[$today['mon']];
	$annee   = $today['year'];
	$heure   = $today['hours'];
	$minute  = $today['minutes'];
	$seconde = $today['seconds'];
?>
</CENTER>
<P>
<HR>
<SMALL><STRONG>@ AudiStat</STRONG></SMALL>
</BODY></HTML>
<?php
}

function db_update_remote_host() {
	global $sql_table;
	
	$query = "SELECT remote_host FROM $sql_table GROUP BY 1";
	$result = mysql_query($query);
	if (!$result) {
		echo "<!-- query $query failed : " . mysql_error() . " -->\n";
		return ;
	}
	while (list($site) = mysql_fetch_row($result)) {
		if (preg_match("/^\d+\.\d+\.\d+\.\d+$/",$site)) {
			$host = gethostbyaddr($site);
			if (!isset($host) || preg_match("/^\d+\.\d+\.\d+\.\d+$/",$host)) {
				// add a final space to avoid re-matching
				$host = $site . " ";
			}
			$q2 = "UPDATE $sql_table SET remote_host=\"$host\" WHERE remote_host=\"$site\"";
			$r2 = mysql_query($q2);
			if (!$r2) {
				echo "<!-- query $q2 failed : " . mysql_error() . " -->\n";
				return ;
			}
		}
	}
}

db_open();
db_update_remote_host();
html_header ($month, $year);



if (isset($month) && isset($year) && !isset($mday)) {
	$querystring = "MONTH(time_str) = $month AND YEAR(time_str) = $year";
	db_query_daystats  ($month, $year);
	db_query_hourstats ($querystring);
	db_query_topurls   ($querystring);
	db_query_topsites  ($querystring);
	db_query_lastsites ($querystring);
	db_query_toprefs   ($querystring);
	db_query_topsearch ($querystring);
	db_query_topagents ($querystring);
	db_query_topctrys  ($querystring);
} elseif (!isset($month) && !isset($year))
	db_query_all_months();

if (isset($month) && isset($year) && isset($mday)) {
	$querystring = "DAYOFMONTH(time_str) = $mday AND MONTH(time_str) = $month AND YEAR(time_str) = $year";
	db_query_lastsites ($querystring);
	db_query_hourstats ($querystring);
	db_query_topurls   ($querystring);
	db_query_topsites  ($querystring);
	db_query_toprefs   ($querystring);
	db_query_topsearch ($querystring);
	db_query_topagents ($querystring);
	db_query_topctrys  ($querystring);

}

html_footer();
db_close();

?>    

