
CREATE TABLE < admin > (
  username text,
  password text,
  session text,
  ip text,
  email_recieved text,
  email_processed text,
  email text,
  id int(11) DEFAULT '0' NOT NULL auto_increment,
  PRIMARY KEY (id)
);


CREATE TABLE < item > (
  id int(11) DEFAULT '0' NOT NULL auto_increment,
  price decimal(9,2),
  shipping_price decimal(9,2),
  name text,
  description text,
  num_ordered int(11),
  category text,
  attributes text,
  product_code text,
  PRIMARY KEY (id)
);


CREATE TABLE < order > (
  id int(11) DEFAULT '0' NOT NULL auto_increment,
  user_id int(11),
  item_ids text,
  sub_total decimal(9,2),
  ship_total decimal(9,2),
  tax decimal(9,2),
  total decimal(9,2),
  cc_name text,
  cc_year text,
  cc_num text,
  s_name text,
  s_address text,
  s_city text,
  s_state text,
  s_zip text,
  s_phone text,
  b_name text,
  b_address text,
  b_city text,
  b_state text,
  b_zip text,
  b_phone text,
  date_bought date,
  date_processed date,
  ship_method text,
  complete char(1),
  cc text,
  cc_month text,
  PRIMARY KEY (id)
);

CREATE TABLE < user > (
  id int(11) DEFAULT '0' NOT NULL auto_increment,
  name text,
  address text,
  city text,
  state text,
  zip text,
  phone text,
  email text,
  session text,
  ip text,
  password text,
  wishlist_ids text,
  PRIMARY KEY (id)
);