#!/usr/local/bin/perl
##############################################
# MeySoft Banner Manager - Version 2.5F
# Revised May 12, 1998
# Copyright (c) 1998 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# WebMaster@MeySoft.com
#
# THIS HEADER MUST REMAIN INTACT
##############################################

require "config25.pl";
require "bm25fn.pl";

alarm(120);

read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

$style="$DATA{'style'}";
$password="$DATA{'password'}";
&check_pw;

$dbp="$CFG{'acct_dir'}/$style";
@CTRL=();
@ACCT=();
@accts=('-');
&get_ctrl_data("$dbp");

$cur=1;
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>Bulk Mail - List Output</TITLE></HEAD>\n";
print "<BODY bgcolor=\"ffffff\">Here are the results of the mailer:<P>\n";
print "<hr size=2>\n";

if($DATA{'message'}){
  $message="$DATA{'message'}";
}else{
  print "<h3>You did not enter any text. You shouldn't send members blank emails...</h3>\n";
  print "<hr size=4><BR><a href=\"$CFG{'admin_form'}\">Back</a>\n</body></html>";
 exit;
}

######################
while($cur <=$CTRL[2]){
  $acct_num=$cur;
  $error_no=0;
   $usermail="";
   $mail="";
   if(-e "$dbp/$acct_num.dat"){
  &get_acct("$dbp","$acct_num");
  $usermail="$ACCT[$EMAIL]";
  $not_in_list=0;
  &isin_list;
  if(($not_in_list==0)&&($ACCT[$TYPE] ne 'deleted')&&($ACCT[$EMAIL] ne 'N/A')){
   push(@accts,$usermail);
 }
 }
$cur++;
}


$error_no=0;
###############
open(LGF,">mail.lst");
 foreach $act(sort @accts){
  if($act ne '-'){
    $usermail="$act";
    print LGF "$act\n";
 }
}
close(LGF);
`chmod $CFG{'file_permissions'} mail.lst`;
##################################
## MAIL LOOP
$sent="";
print "Style: $style  <p>\n";

open(LGF,"mail.lst");
while($line=<LGF>){
 if($line =~ /\n/){ chop($line); }
  $line=~ s/ //g;
  if("$line" ne "$sent"){ 
   print "$line   ---\&gt being sent...<BR>\n";
   $sent="$line";
   &send_msg;
  }
}
close(LGF);
#if(-e "mail.lst"){
#  unlink("mail.lst");
#}
############################
print "<hr size=4><BR>DONE\n</body></html>";
exit;
###################
sub send_msg{
$usermail="$sent";
open(MAIL,"|$CFG{'mail_prog'} -t") or &send_error;
print MAIL "To: $usermail\n";
print MAIL "From: $CFG{'owner_email'}\n";
print MAIL "Reply-to: $CFG{'owner_email'}\n";
print MAIL "Subject: BANNER AD INFORMATION\n\n";
print MAIL "\n$message\n\n";
print MAIL "------------------------------------\n";
print MAIL "Thank you.\n";
print MAIL ".";
close(MAIL);
print "Email: $usermail sent.<BR>\n";
}
#####################
sub send_error{
print "<HR SIZE=2>\n";
print "ERROR: $! Style: $style  Acct: $acct_num Email: $usermail<BR>\n";
$error_no=1;
}
##########################################

sub isin_list{
 foreach $act(@accts){
 if("$act" eq "$usermail"){ 
   $not_in_list=1;
   }else{
   $not_in_list=0;
  }
 }
}
###################
sub check_pw{
open(PW,"<pw.dat");
$pass=<PW>;
close(PW);
 $test_pw=crypt($password,substr($CFG{'encrypt_key'},0,2));
if(!("$test_pw" eq "$pass")){
 $pok=0;
 &send_header("ADMIN RESULTS");
 print "Invalid Admin Password";
 &send_footer;
 exit;
}
}
##########################################
# EOS Last Update: May 12, 1998 Jeffrey L. Meyer