#!/usr/local/bin/perl
######################################################
# Member Multi-code Tracker
# Banner Manager 2.5F 
# Last update: May 13, 1998
# Copyright (c) 1998 MeySoft
#######################################################

require "config25.pl";
require "bm25fn.pl";

alarm(60);

if($ENV{'REQUEST_METHOD'} eq 'POST'){
  read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
}else{
 $data="$ENV{'QUERY_STRING'}";
}

@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
   $field_val=~ tr/+/ /;
   $field_val=~ tr/,/./;
   $field_val=~ tr/\&//;
   $field_val=~ tr/"//;
   $field_val=~ tr/\'//;
   $field_val=~ tr/\`//;
   $field_val=~ tr/\*//;
   $field_val=~ tr/\\//;
   $field_val=~s/<!--(.|\n)*-->//g;
   $field_val=~ s/<([^>]|\n)*>//g;
   $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

##########################################################
$dbp="$CFG{'acct_dir'}/$DATA{'style'}";
$acct_num="$DATA{'acct_num'}";
$si=&style_index("$DATA{'style'}");

@PAGE=();
&get_ctrl_data("$dbp");


&send_header("Page History");
&get_acct("$dbp","$acct_num");

 if(-e "$dbp/MC/1/$acct_num.pgd"){
    open(CNT,"<$dbp/MC/1/$acct_num.pgd")||&send_error("Could not open database file for $dbp/MC/1/$acct_num");
    $qty_allowed=<CNT>;
    close(CNT);
 }else{
  open(NEW,">$dbp/MC/1/$acct_num.pgd");
  print NEW "10";
  close(NEW);
  if(-e "$dbp/MC/1/$acct_num.pgd"){
    `chmod $CFG{'file_permissions'} $dbp/MC/1/$acct_num.pgd`;
  }

  $qty_allowed=10;
}
$mti=0;
$mtc=0;
$ati=0;
$atc=0;
$wti=0;
$wtc=0;
print "<CENTER>";
print "<h3>Page History For:</h3><h4>$ACCT[$USER]</h4>";

     if(&get_page("$dbp","$acct_num","1")==0){
          print "Error: $cnt/$acct_num.pgs\n"; 
     }
     &save_page("$dbp","$acct_num","1");

if($PAGE[$A_IMP] !=0){
  $ratio=($PAGE[$A_HIT] / $PAGE[$A_IMP]) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$s_ratio=substr($s_r,0,4);

$s_ratio=&decimal("$s_ratio");

$extras=0;

print <<"WEB_PAGE";
<table border=1 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0>
<TR bgcolor="#$COLOR{'headers'}">
<TD align=middle colspan=4><font size=4 color="#$COLOR{'header_text'}">
Statistics for banners on your website</font></td>
</tr>
<TR>
<TD align=middle>Multi-code PAGE</TD>
<TD align=middle NOWRAP>TOTAL<BR>Accumulated<BR>Impressions / Clicks* / Ratio</td>
<TD align=middle NOWRAP>Last 30-Days<BR>Impressions / Clicks* / Ratio</td>
<TD align=middle NOWRAP>Last 7-Days<BR>Impressions / Clicks* / Ratio</td></tr>
WEB_PAGE


for($cnt=1; $cnt <= $qty_allowed; $cnt++){
   if(-e "$dbp/MC/$cnt/$acct_num.pgs"){
     $extras=1;
       if(&get_page("$dbp","$acct_num","$cnt")==0){
          print "Error: $cnt/$acct_num.pgs\n";

       }
     &save_page("$dbp","$acct_num","$cnt");


if($PAGE[$A_IMP] !=0){
  $ratio=($PAGE[$A_HIT] / $PAGE[$A_IMP]) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$t_ratio=substr($s_r,0,4);
$t_ratio=&decimal("$t_ratio");
#
if($PAGE[$M_IMP] !=0){
  $ratio=($PAGE[$M_HIT] / $PAGE[$M_IMP]) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$m_ratio=substr($s_r,0,4);
$m_ratio=&decimal("$m_ratio");
#
if($PAGE[$W_IMP] !=0){
  $ratio=($PAGE[$W_HIT] / $PAGE[$W_IMP]) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$w_ratio=substr($s_r,0,4);
$w_ratio=&decimal("$w_ratio");
#
print <<"WEB_PAGE";
<TR>
<TD align=left><a href="reset.cgi?a=$acct_num&s=$DATA{'style'}&p=$cnt&return=$DATA{'return'}&password=$DATA{'password'}">
<img src="$CFG{'images'}/reset.gif" align=absmiddle></a>
<B>$cnt</B> - <a href="$PAGE[$R_4]">$PAGE[$R_4]</a></td>
<TD align=middle NOWRAP>$PAGE[$A_IMP] / $PAGE[$A_HIT] / $t_ratio %</td>
<TD align=middle NOWRAP>$PAGE[$M_IMP] / $PAGE[$M_HIT] / $m_ratio %</td>
<TD align=middle NOWRAP>$PAGE[$W_IMP] / $PAGE[$W_HIT] / $w_ratio %</td></TR>
WEB_PAGE

   $ati=$ati+$PAGE[$A_IMP];
   $atc=$atc+$PAGE[$A_HIT];
   $mti=$mti+$PAGE[$M_IMP];
   $mtc=$mtc+$PAGE[$M_HIT];
   $wti=$wti+$PAGE[$W_IMP];
   $wtc=$wtc+$PAGE[$W_HIT];
}
@PAGE=(0); 
}
#####

if($ati !=0){
  $ratio=($atc / $ati) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$t_ratio=substr($s_r,0,4);
$t_ratio=&decimal("$t_ratio");
#
if($mti !=0){
  $ratio=($mtc / $mti) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$m_ratio=substr($s_r,0,4);
$m_ratio=&decimal("$m_ratio");
#
if($wti !=0){
  $ratio=($wtc / $wti) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$w_ratio=substr($s_r,0,4);
$w_ratio=&decimal("$w_ratio");
print <<"WEBPAGE";
<TR bgcolor="#$COLOR{'bgcolor'}"><TD align=middle>TOTALS</td>
<TD align=middle>$ati / $atc / $t_ratio %</td><TD align=middle>$mti / $mtc / $m_ratio %</td>
<TD align=middle>$wti / $wtc / $w_ratio %</td></tr>
<TR>
<TD  colspan=4 align=middle>* <font size="-1"><I>Clicks represent click-thrus leaving the page</I></font></td>
</tr>
WEBPAGE

print "</TABLE><BR>";


if($DATA{'return'} eq 'admin'){
print <<"WEBPAGE";
<form method="POST" ACTION="$CFG{'cgi_bin_path'}/badmin.cgi">
<INPUT TYPE="image" src="$CFG{'images'}/main.gif">
<INPUT TYPE="hidden" NAME="password" VALUE="$DATA{'password'}" > 
<input type="hidden" name="command" value="login">
</FORM>
WEBPAGE
}else{
print "<A href=\"mlogin.cgi?acct_num=$DATA{'acct_num'}-$si&style=$DATA{'style'}&password=$DATA{'password'}\">";
print "<img src=\"$CFG{'images'}/back.gif\"></a>";
print "<a href=\"$CFG{'member_page'}\"><img src=\"$CFG{'images'}/member.gif\" alt=\"Members Area\" ></a>";
print "<a href=\"$CFG{'banner_page'}\"><img src=\"$CFG{'images'}/mainpage.gif\" alt=\"Main Page\" ></a>";
print "<a href=\"topclick.cgi?$DATA{'style'}\"><img src=\"$CFG{'images'}/click.gif\" alt=\"Top Clicks\" ></a>";
}
print "</CENTER>";
&send_footer;
exit;

###########################################################
sub list_pages{
&send_header("ACTIVE PAGE LIST");

$epdir="$dbp/MC";

for($page=1; $page<100;$page++){
 @files=();
   $tdir="$epdir/$page";
   opendir(DIR,"$tdir");
   @files=sort grep(!/^\./,readdir(DIR));
   closedir(DIR);
   print "PAGE: $page<P>";    
  foreach $file(@files){
       $file=~ s/.pgs//g;
       print "$file<BR>";
     }
}
&send_footer;
exit;
}
#######################
sub send_error{
local($msg)=@_;
print "$msg";
&send_footer;
exit;
}