package Headlines::Drudge;
use Headlines;
@ISA=("Headlines");
use HTML::Parser;
use HTML::TreeBuilder;
sub getlinksL {
  my ($code,$pat) = @_;
  my @alllinks=();
  my $begC = new HTML::TreeBuilder;
  $begC->parse($code);
  my $done = 0;
  foreach $i ( @{ $begC->extract_links } ) {
    my ($link, $linkelem)= @$i;
    if ($link =~ /$pat/) {
      $done = 1;
    }
    unless ($done) {
      push( @alllinks,$i);
    }
  }
  return @alllinks;
}
sub parse {
  my $self=shift;
  my $linkno=0;
  my %res = ();
  my %used= ();
  my $alllinks=();
#  print STDERR "Retrieving Document\n";
  my $doc = $self->retrieve;
  my ($beginning, $left, $center,$right) = split(m,\<td.*?\>,i,$doc);
  #print $center;
  push @alllinks,&getlinksL($beginning,"thistringisnototbefound");
  push @alllinks,&getlinksL($center,"matt.htm");
  push @alllinks,&getlinksL($right,quotemeta("http://www.vny.com/cf/News/upiheadlines.cfm"));
  push @alllinks,&getlinksL($left,quotemeta("http://www.newsday.com/ap/internat.htm"));

#  print STDERR "Document Retrieved\n";
 my $result = [];
#  my $h = new HTML::TreeBuilder;
#  $h->parse($doc);
  for $i (@alllinks) {
    my ($link, $linkelem)= @$i;
    my $k;
   my $content="";

    if (($link =~ m,(),) && ($link !~ /adforce|imgis/)) {
#    if (1) {
      foreach $k (@{$linkelem->content}){
#	print $k,"\n";
	$content .=  $k unless (ref($k) or ($k !~ /\w+/));
	if (ref($k)){
	  if ($k->tag =~ /IMG/i) {
	    $content .= $k->attr('alt');
	  } else {
	    $content .= $k->as_HTML;
	  }
	}
      }
      if ( $link =~ m~javascript:(openWindowDtn|openwin).\s*.([^\'\"]+).\s*,~i){
	$link = $3;
      }
      if ($link =~ m,^/,) {
	$link = "http://www.drudgereport.com" . $link;
      }
      unless ($link =~ m,^http://,) {
	$link = "http://www.drudgereport.com/" . $link;
      }
      
      unless (($link =~ /^mailto:/) || (length($link) < 5)){ 
	$res{$linkno++} = [$content, $link] if ($content =~ /\w+/);
#	push @$result, [ $content,$link] ;
      }
    }
  }


  my $l;
  foreach $l (sort {$a <=> $b} keys %res) {
    if (!exists($used{$res{$l}->[0]})) {
#      print "Found the following link:", $res{$l}->[0], "\t",$res{$l}->[1],"\n";
      push @$result, [$res{$l}->[0], $res{$l}->[1]];
      $used{$res{$l}->[0]} = $res{$l}->[1];
    } else {
       print $res{$l}->[0],$res{$l}->[1];
     }
  }
	
  return $result;
}
1;
