# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..10\n"; }
END {print "not ok 1\n" unless $loaded;}
use Headlines;
use Headlines::Ultra;
use Headlines::News;
use Headlines::Zdnet;
use Headlines::Generic;
use Headlines::Yahoo;
use Headlines::Drudge;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):
my @hls = ();
push @hls,new Headlines::Ultra(	    'slashdot','http://slashdot.org/ultramode.txt');
#push @hls, new Headlines::News(  'news.com' , 'http://www.news.com/');
push @hls,new Headlines::Zdnet(  'ZDNet' , 'http://www.zdnet.com/zdnn/?chkpt=hpqs014');

 my  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =  localtime(time);
 $mon++;
 if ($mon < 10) {
   $mon = "0" . $mon;
 }

 my $the_register_regexp = "$year$mon" . '\d+-\d+.html';
 push @hls,Headlines::Generic->new(  'The Register' , 'http://www.theregister.co.uk/reg-index.html',$the_register_regexp);
 push @hls,Headlines::Yahoo->new(  'Yahoo Top Stories' , 'http://dailynews.yahoo.com/h/ts/',"http://dailynews.yahoo.com/h/nm/");
 push @hls,Headlines::Yahoo->new(  'Yahoo Business' , 'http://dailynews.yahoo.com/h/bs/',"http://dailynews.yahoo.com/h/nm/");
 push @hls,Headlines::Yahoo->new(  'Yahoo Tech' , 'http://dailynews.yahoo.com/h/tc/',"http://dailynews.yahoo.com/h/nm/");
 push @hls,Headlines::Yahoo->new(  'Yahoo Health' , 'http://dailynews.yahoo.com/h/hl/',"http://dailynews.yahoo.com/h/nm/");
 push @hls,Headlines::Ultra->new(	    'mattshouse' , 'http://www.mattshouse.com/ultramode.txt');
 push @hls,Headlines::Drudge->new(	    'Drudge Report', 'http://www.drudgereport.com/');

$j=2;
foreach $i (@hls) {
   print "not" unless(retrieve $i);
   print "ok ",$j++,"\n";
}


