<?php

require_once("lib.settings.php");
require_once("lib.utils.php");

function ERR($str)
{
	if(ARBITROWEB_FLAG_LOGGING)
	{
		error_log("[raw]:".$str."\n", 3, ARBITROWEB_FILENAME_LOG);
	}
}

/* ==== ENTRY POINT ==== */

$URL = FALSE;

if(isset($PATH_INFO))
{
	$slen = strlen($PATH_INFO);
	$tmpURL = substr($PATH_INFO, 1, strlen($PATH_INFO)-1);
	if(ereg("/$", $PATH_INFO))
	{
		$tmpURL = substr($tmpURL, 0, strlen($tmpURL)-1);
	}
	$URL = util_decodeURL($tmpURL);
} else
{
	header("HTTP/1.0 404 Not Found");
	exit();
}

if(isset($QUERY_STRING))
{
	$requestedQUERY = $QUERY_STRING;
} else
{
	$requestedQUERY = FALSE;
}

if($URL)
{
	$fp = fopen($URL, "rb");
	if($fp)
	{
		util_writelog("rawloader", $URL, "200");
		fpassthru($fp);
	}
	else
	{
		util_writelog("rawloader", $URL, "404");
		header ("HTTP/1.0 404 Not Found");
	}
} else
{
	ERR("no url specified.");
	header ("HTTP/1.0 404 Not Found");
}

?>