#!/usr/bin/perl
#######################################################
#		Home Free v3.24n (Nearly Null)
#     
#    	Created by Solution Scripts
# 		Email: solutions@solutionscripts.com
#		Web: http://solutionscripts.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Solution Scripts  All Rights Reserved.
#
# Selling or redistributing the code for this program 
# without prior written consent is expressly forbidden. 
# In all cases copyright and header must remain intact.
#
#######################################################

$|=1;

require "variables.pl";
require "dblib.pl";
require "adminlib.pl";
require "dem_data.pl";
require "english.lang";

@colors=("#e1e1e1","#ededed");
$time = time;

&initalize;

if ($INPUT{'action'} eq "browse") { &browse; }
elsif ($INPUT{'action'} eq "search") { &browse_final; }
elsif ($INPUT{'action'} eq "onhold_remove") { &onhold_remove; }
elsif ($INPUT{'action'} eq "onhold") { &onhold; }
elsif ($INPUT{'action'} eq "delete_account") { &del; }
elsif ($INPUT{'action'} eq "delete") { &delete_pop; }
elsif ($INPUT{'action'} eq "delete_file") { &delete_file; }
elsif ($INPUT{'action'} eq "delete_folder") { &delete_folder; }
elsif ($INPUT{'action'} eq "view_account") { &view_account; }
elsif ($INPUT{'action'} eq "view_dir") { &view_dir; }
elsif ($INPUT{'onhold_final'}) { &onhold_final; }
elsif ($INPUT{'view_account'}) { &view_account; }
elsif ($INPUT{'view_final'}) { &view_final; }
elsif ($INPUT{'del'}) { &del; }
elsif ($INPUT{'delete_pop_final'}) { &delete_pop_final; }
elsif ($INPUT{'del_select'}) { &del_select; }
elsif ($INPUT{'browse_final'}) { &browse_final; }

&print_login;
&Footer;

########## VIEW ACCOUNT ###########
sub view_account {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }

my $message = $_[0];

&Header(4);

$Account::cata = $INPUT{'cata'};
$Account::account = $INPUT{'account'};

$faccount =0;
$accdir="Base Dir.";

unless ($Account::cata) { $Account::cata = "accounts"; }
unless ($INPUT{'view_dir'}) { $INPUT{'view_dir'} = "accounts"; }

my $got_acc = &Account::get_account;
unless ($got_acc) {
print <<EOF;
<BR><BR>
No such accout as <B>$Account::account</B> in category <B>$Account::cata</B>
<BR><BR>
EOF
&Footer;
exit;
}

if ($Account::last_log) {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($Account::last_log);
	$mon++;
	$year += 1900;
	$now = "$mon.$mday.$year";
}
else { $now ="never"; }
$total_size_acc = $total_size + $Account::size_added;
unless ($Account::hf_on) { $Account::hf_on= "on"; }

$num_files = 0;
$num_folders =0;
$total_k = 0;

unless($Account::signup_ip) { $Account::signup_ip = "NA"; }
unless ($Account::last_ip) { $Account::last_ip = "NA"; }

%cata_list = &Account::get_cata_hash;

@cata_data = split(/\|/,$cata_list{$Account::cata});
if ($cata_data[0]) { $acc_dir = "$cata_data[0]/$Account::account"; }
else { $acc_dir = $Account::account; }

print <<EOF; 
<FORM METHOD=POST ACTION="$cgiurl">
<INPUT TYPE="HIDDEN" NAME="username" VALUE="$username">
<INPUT TYPE="HIDDEN" NAME="account" VALUE="$Account::account">
<INPUT TYPE="HIDDEN" NAME="cata" VALUE="$Account::cata">
<CENTER><font face=arial size=-1><B>$message <BR><BR>View Account</B> <A HREF="$help/view.html"><font face="arial" size="+1" color=red><B>?</B></font></A>
<table cellpadding=5 border=0 cellspacing=0 width=90% align=center>
EOF
if ($Account::onhold) {
print <<EOF;
<TR bgcolor=$colors[1]><TD colspan=2 align=center>
<font face=arial size=-1 color=red><B>ACCOUNT ON HOLD</B><BR>
$Account::onhold
</TD></TR>
EOF
}
print <<EOF;
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Account name:</TD><TD align=left><font face=arial size=-1 color=red>$Account::account
</TD></TR>
EOF
if ($category) {
print <<EOF;
<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
$cata_name:</TD><TD align=left><font face=arial size=-1 color=red>$catapretty
</TD></TR>
EOF
}
print <<EOF;
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Url:</TD><TD align=left><font face=arial size=-1 color=red><A HREF="$url/$acc_dir" target=main>$url/$acc_dir</A>
</TD></TR>
<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Email:</TD><TD align=left><font face=arial size=-1 color=red><A HREF="mailto:$Account::email">$Account::email</A>
</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Password:</TD><TD align=left><font face=arial size=-1 color=red><input type="Text" name="password" value="$Account::pwd" size="15">
</TD></TR>
<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Signup IP:</TD><TD align=left><font face=arial size=-1 color=red>$Account::signup_ip
</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Last Login IP:</TD><TD align=left><font face=arial size=-1 color=red>$Account::last_ip
</TD></TR>
<TR bgcolor=$colors[0]><TD align=left>
<A HREF="$help/hold.html"><font face="arial" size="+1" color=red><B>?</B></font></A>&nbsp;&nbsp;
<font face=arial size=-1>
On Hold:</FONT>
</TD><TD align=left><font face=arial size=-1 color=red><input type="Text" name="on_hold" value="$Account::onhold" size="30">
</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Number of files:</TD><TD align=left><font face=arial size=-1 color=red>$Account::num_files
</TD></TR>
<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Number of folders:</TD><TD align=left><font face=arial size=-1 color=red>$Account::num_dirs
</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Space Taken:</TD><TD align=left><font face=arial size=-1><font color="Red">$Account::size</font> k of $total_size_acc k<BR>

</TD></TR>
<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Add more space:</TD><TD align=left><font face=arial size=-1 color=red>$total_size k + <INPUT TYPE="TEXT" NAME="size" VALUE="$Account::size_added" SIZE=4> K
</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Display Headers and Footers:</TD><TD align=left><font face=arial size=-1 color=red>
<input type="Checkbox" name="header_footer" value="off"
EOF

if ($Account::hf_on eq 'off') {
	print " CHECKED ";
}
 
print <<EOF;
> &nbsp;&nbsp;off/no</TD></TR>

<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Allow Web Board:</TD><TD align=left><font face=arial size=-1 color=red>
<input type="Checkbox" name="www_board" value="on"
EOF

if ($Account::www_of eq 'on') {
	print " CHECKED ";
}
 
print <<EOF;
> &nbsp;&nbsp;on</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Allow Guestbook:</TD><TD align=left><font face=arial size=-1 color=red>
<input type="Checkbox" name="gbook" value="on"
EOF

if ($Account::gbook_of eq 'on') {
	print " CHECKED ";
}
 
print <<EOF;
> &nbsp;&nbsp;on</TD></TR>
<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Allow FTP importing:</TD><TD align=left><font face=arial size=-1 color=red>
<input type="Checkbox" name="ftp_per" value="on"
EOF

if ($Account::ftp_per eq 'on') {
	print " CHECKED ";
}
 
print <<EOF;
> &nbsp;&nbsp;on</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Use of Form Mail:</TD><TD align=left><font face=arial size=-1 color=red>
<input type="Checkbox" name="formmail_of" value="on"
EOF

if ($Account::formmail_of eq 'on') {
	print " CHECKED ";
}
 
print <<EOF;
> &nbsp;&nbsp;on</TD></TR>

<TR bgcolor=$colors[0]><TD align=left><font face=arial size=-1>
Name and Description:</TD><TD align=left><font face=arial size=-2>$Account::website_name<BR>$Account::website_des
</TD></TR>
<TR bgcolor=$colors[1]><TD align=left><font face=arial size=-1>
Last logged in:</TD><TD align=left><font face=arial size=-1 color=red>$now
</TD></TR>
EOF
if ($category) {
	if ($Account::moderator) { $Account::moderator = ",$Account::moderator,"; }
	$select ='';
	
	open (ACC, "$path/categories.txt");
	@cata_data = <ACC>;
	close (ACC);

	foreach $cata_line(@cata_data) {
		chomp($cata_line);
		@abbo = split(/\|/,$cata_line);
		($key,$abbo[0]) = split(/\%\%/,$abbo[0]);

		if ($Account::moderator =~ /\,$key\,/) { $ssel = "SELECTED"; }
		else { $ssel = ""; }
		$select .= "<OPTION VALUE=\"$key\" $ssel>$abbo[1]\n";	
	}
$acc_sel = "";
$none_sel = "";
if ($Account::moderator =~ /\,accounts\,/) { $acc_sel = "SELECTED"; }
unless ($Account::moderator) { $none_sel = "SELECTED"; }
print <<EOF;
<TR bgcolor=$colors[0]><TD ALIGN=left>
<A HREF="$help/moderator.html"><font face="arial" size="+1" color=red><B>?</B></font></A>&nbsp;&nbsp;
<font face=arial size=2>
Moderator Categories:
</TD><TD>
<select name="moder" size="4" multiple>
<OPTION VALUE="" $none_sel>No $cata_name
<OPTION VALUE="accounts" $acc_sel>Base Dir.
$select</select>
</TD></TR>
EOF
}
else {
$acc_sel = "";
$none_sel = "";
if ($Account::moderator =~ /\,accounts\,/) { $acc_sel = "SELECTED"; }
unless ($Account::moderator) { $none_sel = "SELECTED"; }
print <<EOF;
<TR bgcolor=$colors[1]><TD ALIGN=left>
<A HREF="$help/hold.html"><font face="arial" size="+1" color=red><B>?</B></font></A>&nbsp;&nbsp;
<font face=arial size=2>
Moderator Categories:
</TD><TD>
<select name="moder" size="4" multiple>
<OPTION VALUE="" $none_sel>No $cata_name
<OPTION VALUE="accounts" $acc_sel>Base Dir.
</select>
</TD></TR>
EOF
}


print <<EOF;
<TR bgcolor=$colors[0]><TD>
<font face=arial size=2>Custom Status Icon
</TD><TD>
<input type="Text" name="search_status" value="$Account::icon_url" size="30">
</TD>
</TR>
<TR bgcolor=$colors[1]><TD>
<font face=arial size=2>Additional per-Account file types
<BR><font face=arial size=1>Seperate each one by a comma (.shtml,.zip,.mp3)
</TD><TD>
<input type="Text" name="add_types" value="$Account::file_types" size="30">
</TD></TR></TABLE>
<BR><BR>

EOF

$INPUT{'email'} = $Account::email;


$INPUT{'name'} = $Account::name;
$INPUT{'password'} = $Account::pwd;

$INPUT{'address'} = $Account::address;
$INPUT{'city'} = $Account::city;
$INPUT{'state'} = $Account::state;
$INPUT{'zip'} = $Account::zip;
$INPUT{'country'} = $Account::country;
$INPUT{'tele'} = $Account::telephone;
$INPUT{'gender'} = $Account::gender;
$INPUT{'age'} = $Account::age;
$INPUT{'icq'} = $Account::icq;
$INPUT{'month'} = $Account::month;
$INPUT{'day'} = $Account::day;
$INPUT{'year1'} = $Account::year1;
$INPUT{'year2'} = $Account::year2;
$INPUT{'marital'} = $Account::marital;
$INPUT{'edu'} = $Account::education;
$INPUT{'inc'} = $Account::income;
$INPUT{'job'} = $Account::occupation;
$INPUT{'dob'} = $Account::d_o_b;
$INPUT{'custom_1'} = $Account::custom_1;
$INPUT{'custom_2'} = $Account::custom_2;
$INPUT{'custom_3'} = $Account::custom_3;
$INPUT{'custom_4'} = $Account::custom_4;
$INPUT{'custom_5'} = $Account::custom_5;
$INPUT{'custom_6'} = $Account::custom_6;
$INPUT{'custom_7'} = $Account::custom_7;
$INPUT{'custom_8'} = $Account::custom_8;
$INPUT{'custom_9'} = $Account::custom_9;
$INPUT{'custom_10'} = $Account::custom_10;



&info_name;
&info_email;
&info_address;
&info_city;
&info_zip;
&info_country;
&info_tele;
&info_gender;
&info_marital;
&info_icq;
&info_edu;
&info_inc;
&info_job;
&info_dob;
&info_custom(1);
&info_custom(2);
&info_custom(3);
&info_custom(4);
&info_custom(5);
&info_custom(6);
&info_custom(7);
&info_custom(8);
&info_custom(9);
&info_custom(10);

print <<EOF;
<table width=600 cellpadding=5 cellspacing=0 border=0 align=center>
<TR bgcolor=silver><TD colspan=4 align=center>
$css<B>User Entered Information</B>
</TD></TR>
$html
<TR bgcolor=silver>
<TD colspan=4 align=center>
<INPUT TYPE=SUBMIT name="view_final" value=" Change Account Information ">
</TD></TR>
</TABLE>
</FORM>
<BR><BR>
<FORM METHOD=POST ACTION="manager.cgi">
<INPUT TYPE="HIDDEN" NAME="account" VALUE="$Account::account">
<INPUT TYPE="HIDDEN" NAME="cata" VALUE="$Account::cata">
<INPUT TYPE="HIDDEN" NAME="password" VALUE="$Account::pwd">
<INPUT TYPE="SUBMIT" NAME="log" VALUE="Log into file manager for $Account::account ">
</FORM><BR><BR>
&nbsp; &nbsp; &nbsp;<TABLE border=0 cellspacing=0 cellpadding=15 align=left>
<TR><TD>
<font face=arial size=-1>
<font color=red>$Account::num_files</FONT> files<BR>
<font color=red>$Account::num_dirs</FONT> Directories
<BR><BR>
EOF


undef $/;
open (ACC, "$free_path/$acc_dir/_data/files_hf.txt");
$ffiles = <ACC>;
close (ACC);
$/ = "\n";


@files = split(/\n/,$ffiles);

foreach $file(@files) {
	$url_base = $file;
	$url_base =~ s/$free_path\///;
	$file =~ s/$free_path\/$acc_dir\///;

	@pfile = split(/\//,$file);
	$numfile = @pfile;
	
	$a=0;
	while ($a < $numfile) {
		print "<NOBR>\&nbsp\; \&nbsp\; ";
		$show_file = $pfile[$a];
		$a++;
		
	}
	
	$ftype="folder";
	if ($file =~ /\./) {
		print "\&nbsp\; <IMG SRC=\"$url_to_icons/list.gif\"> ";
		$ftype="file";
	}
	else { 
		print "<IMG SRC=\"$url_to_icons/fold.gif\"> ";
	}
	
print <<EOF;
<A HREF="$url/$url_base" target="browse">$show_file</A>
<SMALL><A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=delete_$ftype&account=$Account::account&cata=$Account::cata&file=$file','delete','toolbar=no,location=no,directories=no,status=no,width=300,height=150')";>[delete]</A>
</SMALL><BR></NOBR>
EOF

}	

print <<EOF;
</TD><TD valign=top>
<font face=arial size=-1>
<BR><BR>
<B>
<A HREF="$files::browse?username=$INPUT{'username'}&action=delete_account&account=$Account::account&cata=$Account::cata">Delete Account</A>
</B>
<BR><BR>

<B>Note:</B> 
<BR><BR>
Deleting account will delete all files and folders.
<BR><BR>
Deleting a folder wih delete every file<BR>
and folder contained within that folder.
<BR><BR>
<A HREF="$files::browse?username=$INPUT{'username'}&action=view_account&account=$Account::account&cata=$Account::cata">Click here to refresh screen</A>
<BR><BR></TD>
</TR></TABLE>
EOF

&Footer;
exit;
}

############ CHANGES ##########
sub view_final {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }
if ($INPUT{'username'} eq "demo") { &unauth; }

$Account::cata = $INPUT{'cata'};

$Account::account = $INPUT{'account'};

&Account::get_account;

$Account::email = $INPUT{'email'};
$Account::name = $INPUT{'name'};
$Account::pwd = $INPUT{'password'};

if ($INPUT{'header_footer'} eq 'off'){
	$Account::hf_on = "off";
}
else {
	$Account::hf_on = "on";
}

$Account::www_of = $INPUT{'www_board'};

$Account::onhold = $INPUT{'on_hold'};
$Account::address = $INPUT{'address'};
$Account::city = $INPUT{'city'};
$Account::state = $INPUT{'state'};
$Account::zip = $INPUT{'zip'};
$Account::country = $INPUT{'country'};
$Account::telephone = $INPUT{'tele'};
$Account::gender = $INPUT{'gender'};
$Account::age = $INPUT{'age'};
$Account::icq = $INPUT{'icq'};
$Account::education = $INPUT{'edu'};
$Account::income = $INPUT{'inc'};
$Account::occupation = $INPUT{'job'};
$Account::d_o_b = "$INPUT{'month'},$INPUT{'day'},$INPUT{'year1'},$INPUT{'year2'}";
$Account::moderator = $INPUT{'moder'};
$Account::gbook_of = $INPUT{'gbook'};
$Account::ftp_per = $INPUT{'ftp_per'};
$Account::icon_url = $INPUT{'search_status'};
$Account::file_types = $INPUT{'add_types'};
$Account::size_added = $INPUT{'size'};

$Account::custom_1 = $INPUT{'custom_1'};
$Account::custom_2 = $INPUT{'custom_2'};
$Account::custom_3 = $INPUT{'custom_3'};
$Account::custom_4 = $INPUT{'custom_4'};
$Account::custom_5 = $INPUT{'custom_5'};
$Account::custom_6 = $INPUT{'custom_6'};
$Account::custom_7 = $INPUT{'custom_7'};
$Account::custom_8 = $INPUT{'custom_8'};
$Account::custom_9 = $INPUT{'custom_9'};
$Account::custom_10 = $INPUT{'custom_10'};
$Account::marital = $INPUT{'marital'};

$Account::formmail_of = $INPUT{'formmail_of'};

&Account::print_account;

&view_account("$Account::account updated");
exit;
}


########## VIEW ACCOUNT INTERFACE ##########
sub browse {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/) || ($access_level =~ /onhold/)) { &unauth; }

&Header(4);

print <<EOF;
<FORM METHOD=POST ACTION="$cgiurl" name="address">
<input type="Hidden" name="username" value="$username">
<TABLE border=1 cellpadding=3 cellspacing=0 width=90% align=center>
<TR bgcolor=$colors[0]><TD colspan=2>$css_font<INPUT TYPE=checkbox name="b_never_log"> Show accounts never activated and created more than <INPUT TYPE=text name=b_never_log_time value=14 size=4> days ago</TD></TR>

<TR bgcolor=$colors[1]><TD colspan=2>$css_font<INPUT TYPE=checkbox name="b_log"> Show accounts not logged into in <INPUT TYPE=text name=b_log_time value=14 size=4> days.</TD></TR>

<TR bgcolor=$colors[0]><TD colspan=2>$css_font<INPUT TYPE=checkbox name="b_onhold"> Show accounts currently onhold</TD></TR>
<TR bgcolor=$colors[1]><TD colspan=2>$css_font<INPUT TYPE=checkbox name="b_onhold_approve"> Show accounts awaiting admin approval</TD></TR>


<TR bgcolor=$colors[0]><TD valign=top><NOBR>$css_font Accounts that begin with the letter/number:</NOBR>
</TD><TD width=50%><SELECT name=letters multiple size=6>
<OPTION value="ALL" Selected>All Letters
EOF
foreach $ch(@char_set) {
	print "<OPTION VALUE=\"$ch\">$ch\n";
}
print <<EOF;
</SELECT></TD></TR>
<TR bgcolor=$colors[0]><TD valign=top><NOBR>$css_font Categories:</NOBR>
</TD><TD width=50%><SELECT name=cata multiple size=6>
<OPTION value="_all_" Selected>All Categories
<OPTION value="accounts">Base Directory
EOF

%cata_list = &Account::get_cata_hash;

while ( ($key, $value) = each(%cata_list) ) {
	print "<OPTION VALUE=\"$key\">$key\n";
}

print <<EOF;
</SELECT></TD></TR>
<TR bgcolor=$colors[1]><TD valign=top>
$css_font
Show accounts joining:
</TD><TD>
$css_font
<input type="Radio" name="start_on" value="on"> <font color=red><B>on</B></FONT><BR>
<input type="Radio" name="start_on" value="after"> <font color=red><B>after</B></FONT><BR>
<input type="Radio" name="start_on" value="before"> <font color=red><B>before</B></FONT><BR>
<BR>this date:
<input type="Text" name="date" size="10">
</TD></TR>
<TR bgcolor=$colors[0]><TD valign=top>
$css_font
Show only accounts taking up:
</TD><TD><input type="Radio" name="size_on" value="more"> <font color=red><B>more</B></FONT><BR>
<input type="Radio" name="size_on" value="less"> <font color=red><B>less</B></FONT><BR>
<BR>than <input type="Text" name="size" size="10"> kb of space.
</TD></TR><TR bgcolor=$colors[1]>
<TD valign=top>
$css_font
Accounts using:
</TD><TD><input type="Radio" name="files_on" value="more"> <font color=red><B>more</B></FONT><BR>
<input type="Radio" name="files_on" value="less"> <font color=red><B>less</B></FONT><BR>
<BR>than <input type="Text" name="files" size="8"> files in total.
</TD>
</TR>
<TR bgcolor=$colors[0]><TD valign=top>
$css_font
Sort matching accounts by:
</TD><TD>
<input type="Radio" name="sort" value="name" checked> <font color=red><B>Name</B></FONT><BR>
<input type="Radio" name="sort" value="size"> <font color=red><B>Size</B></FONT><BR>
<input type="Radio" name="sort" value="files"> <font color=red><B>Number files</B></FONT><BR>
<input type="Radio" name="sort" value="joined"> <font color=red><B>Date joined</B></FONT><BR>
<input type="Radio" name="sort" value="last"> <font color=red><B>Date last logged in</B></FONT>
</TD>
</TR>
<TR bgcolor=$colors[1]>
<TD valign=top>
$css_font
Accsending/Descending:
</TD><TD><input type="Radio" name="asc_dec" value="asc" CHECKED> <font color=red><B>Asc</B></FONT><BR>
<input type="Radio" name="asc_dec" value="dec"> <font color=red><B>Dec</B></FONT>
</TD>
</TR>

<TR bgcolor=$colors[0]>
<TD valign=top>
$css_font
# Accounts per page:
</TD><TD>
<input type="Text" name="num_show" value="25" size="3">
<input type="Hidden" name="num_start" value="1">
</TD>
</TR>
<TR bgcolor=$colors[1]><TD colspan=2>$css_font
Where account emaill address contains: <INPUT TYPE=text name="email_contain" size=10></TD></TR>


<TR bgcolor=$colors[0]><TD colspan=2 align=center><INPUT TYPE=SUBMIT NAME="browse_final" value=" Show Accounts "></TD></TR>
</TABLE>
</FORM>
EOF
&Footer;
exit;
}

######### BROSWE IT ##########
sub browse_final {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/) || ($access_level =~ /onhold/)) { &unauth; }

&Header(4);

print <<EOF;
<FORM METHOD=POST ACTION="$cgiurl" name="address">
<input type="Hidden" name="username" value="$username">
<TABLE border=1 cellpadding=3 cellspacing=0 width=90% align=center>
<TR bgcolor=silver>
<TD><font face=arial size=-2>-</TD>
<TD><font face=arial size=-2>X</TD>
<TD><font face=arial size=-2>
Account</TD>
<TD><font face=arial size=-2>Creation date</TD>
<TD><font face=arial size=-2>Last login</TD>
<TD><font face=arial size=-2>size</TD>
<TD><font face=arial size=-2>Dirs</TD>
<TD><font face=arial size=-2>Files</TD>
<TD><font face=arial size=-2>-</TD>
<TD><font face=arial size=-2>-</TD>
</TR>
EOF

$num_total = 0;
$shown=0;
$shown=$shown + $INPUT{'num_start'};
$num_show = $INPUT{'num_show'} + $INPUT{'num_start'};


%cata_list = &Account::get_cata_hash;
$cata_list{'accounts'} = 1;

@selcata = split(/\,/,$INPUT{'cata'});

foreach $ssel(@selcata) {
	$print_cata{$ssel} = 1;
}


unless ($INPUT{'sort'}) {
	$INPUT{'sort'} = "name";
}

while ( ($key, $value) = each(%cata_list) ) {
	## CATA SLECT ##
	unless ($print_cata{'_all_'}) {
		unless ($print_cata{$key}) { 
			next;
		}
	}

	$cata_show_html = 0;
		
	$cata_html = qq!
		<TR bgcolor=silver>
		<TD colspan=10 align=center><font face=arial size=-1>Category: <Font color=blue>$key</FONT></TD>
		</TR>
	!;



	undef %acc_list;
	undef @html;
	undef %sort;
	undef %content;
		
	%acc_list = &Account::get_acc_hash($key);
	$a=0;
	while ( ($akey, $avalue) = each(%acc_list) ) {
		@acco = split(/\|/,$avalue);
		
		my @accarray = split(//,$akey);
		## LETTER SELECT ##
		unless ($INPUT{'letters'} =~ /ALL/) {
			unless ($INPUT{'letters'} =~ /$accarray[0]/) { 
				next;
			}
		}
		
		
		## NEVER LOG CHECK ##
		if ($INPUT{'b_never_log'}) {
			unless ($acco[5]) {
				$t_time = $time - $acco[4];
				$tt_time = $t_time / 86400;
				if ($tt_time < $INPUT{'b_never_log_time'}) { next; }			 
			}
			else { next; }
			
		}	

		## LAST LOGIN TIME ##
		if ($INPUT{'b_log'}) {
			unless ($acco[5]) { next; }
			
			$t_time = $time - $acco[5];
			$tt_time = $t_time / 86400;
			if ($tt_time < $INPUT{'b_log_time'}) { next; }	
			
		}

		## ONHOLD ##
		if ($INPUT{'b_onhold'}) {
			unless ($acco[18]) { next; }
		}

		## CONFIRM ##
		if ($INPUT{'b_onhold_approve'}) {
			unless ($acco[18] =~ /All new accounts/gi) { next; }
		}
		
	
		## CHECK SPACE ##
		if ($INPUT{'size_on'} && $INPUT{'size_on'}) {
			if (($INPUT{'size_on'} eq "more") && ($INPUT{'size'} >= $acco[3])) { next; }
			if (($INPUT{'size_on'} eq "less") && ($INPUT{'size'} <= $acco[3])) { next; }
		}
		
		## CHECK # FILES ##
		if ($INPUT{'files_on'} && $INPUT{'files_on'}) {
			if (($INPUT{'files_on'} eq "more") && ($INPUT{'files'} >= $acc[40])) { next; }
			if (($INPUT{'files_on'} eq "less") && ($INPUT{'files'} <= $acc[40])) { next; }
		}
		
		## CREATION DATE ##
		if ($acco[4]) {
 	       ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($acco[4]);
 	       $mon++;
 	       $year += 1900;
 	       $create_data = "$mon.$mday.$year";
		}
		else { $create_data ="never"; }

		## LAST LOGIN ##
		if ($acco[5]) {
 	       ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($acco[5]);
 	       $mon++;
 	       $year += 1900;
 	       $last_log = "$mon.$mday.$year";
		}
		else { $last_log ="never"; }

		## EMAIL ##
		if ($INPUT{'email_contain'}) {
			unless ($acco[0] =~ /$INPUT{'email_contain'}/gi) { next; }
		}
		unless ($acco[3]) { $acco[3]= "N.A."; }
		unless ($acco[39]) { $acco[39]= "N.A."; }
		unless ($acco[40]) { $acco[40]= "N.A."; }
		
		$html = qq!

			<TR bgcolor=BGGCOLOR>
			<TD><font face=arial size=-2>TNUMBER</TD>
			<TD><font face=arial size=-2>
			<INPUT TYPE=CHECKBOX NAME="accdel_$akey|$key"></TD>
			<TD><NOBR><FONT FACE=arial size=-2>
			<A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=view_account&account=$akey&cata=$key','view')";>$akey</A><BR>
			<A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=view_dir&account=$akey&cata=$key&popup=1','fold','toolbar=no,location=no,directories=no,status=no,width=300,height=400')";><IMG SRC="$url_to_icons/fold.gif" border=0 alt="View files folders"></A>

			<A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=view_account&account=$akey&cata=$key&popup=1','view')";><IMG SRC="$url_to_icons/admin_view.gif" border=0 alt="View $akey"></A>
			<A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=onhold&account=$akey&cata=$key','onhold','toolbar=no,location=no,directories=no,status=no,width=300,height=150')";><IMG SRC="$url_to_icons/admin_onhold.gif" border=0 alt="Onhold $account"></A>
			<A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=delete&account=$akey&cata=$key','delete','toolbar=no,location=no,directories=no,status=no,width=300,height=150')";><IMG SRC="$url_to_icons/admin_delete.gif" border=0 alt="Delete $account"></A></NOBR></TD>
			<TD><font face=arial size=-2>$create_data</TD>
			<TD><font face=arial size=-2>$last_log</TD>
			<TD><font face=arial size=-2>$acco[3]</TD>
			<TD><font face=arial size=-2>$acco[39]</TD>
			<TD><font face=arial size=-2>$acco[40]</TD>
			<TD><font face=arial size=-2>-</TD>
			<TD><font face=arial size=-2>-</TD>
			</TR>
		!;
		
		if ($acco[18]) {
			$html .= qq!
				<TR bgcolor=BGGCOLOR>
				<TD colspan=10><font face=arial size=-2>
				<font color=red>Onhold:</FONT> $acco[18]
				</TD></TR>
			!;
		}	
		
		if ($INPUT{'sort'} eq "name") { 
			$sort{$akey} = $akey;
			$content{$akey} = $html;
		}
		elsif ($INPUT{'sort'} eq "size") {
			$sort{$akey} = "$acco[3]";
			$content{$akey} = $html;
		}
		elsif ($INPUT{'sort'} eq "files") {
			$sort{$akey} = $acco[40];
			$content{$akey} = $html;
		}
		elsif ($INPUT{'sort'} eq "joined") {
			$sort{$akey} = "$acco[4]";
			$content{$akey} = $html;
		}
		elsif ($INPUT{'sort'} eq "last") {
			$sort{$akey} = "$acco[5]";
			$content{$akey} = $html;
		}
		
		
		$a++;	
#		print "$akey -- $avalue<BR>";
	}

	$atleastone = 0;
	if (($INPUT{'sort'} eq "name")) {
		foreach $pkey (sort_hasp(\%sort)) {
			if ($col) { $col=0; }
			else { $col++; }
			$num_total++;
			$content{$pkey} =~ s/BGGCOLOR/$colors[$col]/gi;
			$content{$pkey} =~ s/TNUMBER/$num_total/gi;
			$atleastone = 1;

			if (($num_total >= $INPUT{'num_start'}) && ($shown < $num_show)) {
				unless ($cata_show_html) { 
					$cata_show_html = 1;
					print $cata_html; 
				}
				print $content{$pkey};
				$shown++;
			}

		}
	}
	elsif (($INPUT{'sort'} eq "joined") || ($INPUT{'sort'} eq "last") || ($INPUT{'sort'} eq "size") || ($INPUT{'sort'} eq "files")) {
		foreach $pkey (sort_hashs(\%sort)) {
			if ($col) { $col=0; }
			else { $col++; }
			$num_total++;
			$content{$pkey} =~ s/BGGCOLOR/$colors[$col]/gi;
			$content{$pkey} =~ s/TNUMBER/$num_total/gi;
			$atleastone = 1;

			if (($num_total >= $INPUT{'num_start'}) && ($shown < $num_show)) {
				unless ($cata_show_html) { 
					$cata_show_html = 1;
					print $cata_html; 
				}
				print $content{$pkey};
				$shown++;
			}
		}	
	}

	unless($atleastone) {
		if (($num_total >= $INPUT{'num_start'}) && ($shown < $num_show)) {
			unless ($cata_show_html) { print $cata_html; }
print <<EOF;
<TR bgcolor=$colors[0]>
<TD colspan=10 align=center><font face=arial size=-1>No matching accounts</FONT></TD>
</TR>
EOF
		}

	}

}

$ptotal = $num_total / $INPUT{'num_show'};


print <<EOF;
<TR bgcolor=silver><TD colspan=3>
<input name="allbox" type="checkbox" value="Check All" onClick="CheckAll();">
<FONT FACE=arial size=1>Check All</TD><TD colspan=7 align=center>
<INPUT TYPE=SUBMIT name=del_select value=" Delete Selected Accounts"></TD></TR>
<TR bgcolor=silver>
<TD colspan=10><FONT FACE=arial size=-2>
Total accounts found: $num_total<BR>Page: 
EOF

while ( ($name, $value) = each(%INPUT) ) {
	unless (($name eq "num_start") || ($name eq "browse_final") || ($name eq "action")) {
		$string .= "\&$name\=$value";
	}
}

$b=1;
while ($b <= $ptotal) {
	$max = $b * $INPUT{'num_show'};
	$min = $max - $INPUT{'num_show'};
	
	if (($INPUT{'num_start'} < $max) && ($INPUT{'num_start'} >= $min)) {
		print "<font color=red>$b</font> - ";
	}
	else {
		$min++;
print <<EOF;
<A HREF="$files::browse?action=search$string&num_start=$min">$b</A> - 
EOF

	}

$b++;
}

if ($num_total > $max) {
	$min = $min + 1 + $INPUT{'num_show'};
print <<EOF;
<A HREF="$files::browse?action=search$string&num_start=$min">$b</A> - 
EOF
}	


print <<EOF;
</TD></TR></TABLE>
</FORM>
<SCRIPT>
function CheckAll() {
	for (var i=0;i<document.address.elements.length;i++) {
		var e = document.address.elements[i];
		if (document.address.elements[i].name != 'allbox') {
			e.checked = document.address.allbox.checked;
    		}
  	}
}
</SCRIPT>

EOF

&Footer;
exit;
}


########## CONFIRM DELETE ##########
sub delete {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }

	
print <<EOF;
<HTML><HEAD><TITLE>Confirm Deletion</TITLE></HEAD>
<BODY bgcolor=white link=blue vlink=blue>
<CENTER>
<font face=arial>
Really delete account: <font color=red><B>$INPUT{'account'}</B></FONT><BR><BR>
<A HREF="$files::admin?username=$INPUT{'username'}&action=delete_final&account=$INPUT{'account'}&cata=$INPUT{'cata'}"><B>Yes, Delete</B></A><BR><BR>
<A HREF="#" onClick="window.close()";><B>No, Close Window</B></A>
</BODY></HTML>
EOF
exit;
}


########## REMOVE ONHOLD REASON ##########
sub onhold_remove {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/) || ($access_level =~ /onhold/)) { &unauth; }


$account = $INPUT{'account'};
$cata = $INPUT{'cata'};

&Account::get_account;

print "<HTML><HEAD><TITLE>Removed from onhold</TITLE><BODY>\n<font face=arial><CENTER>Account: ";
print "<font color=red><B>$account</B></FONT> removed from onhold status<BR><BR>\n";
print "<A HREF=\"\#\" onClick=\"window\.close\(\)\"\;><B>Close Window</B></A></BODY></HTML>\n";
exit;
}

########## EDIT ONHOLD REASON ##########
sub onhold {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/) || ($access_level =~ /onhold/)) { &unauth; }


$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;

print <<EOF;
<HTML><HEAD><TITLE>$Account::account</TITLE><BODY>
<FORM METHOD=POST ACTION="$cgiurl" name="address">
<input type="Hidden" name="username" value="$username">
<input type="Hidden" name="account" value="$Account::account">
<input type="Hidden" name="cata" value="$Account::cata">
<font face=arial><CENTER>Account:
<font color=red><B>$Account::account</B></FONT> onhold status<BR><BR></FONT><FONT face=arial size=-1>
<INPUT TYPE=TEXT name=onhold_reason value="$Account::onhold" size=25><BR>
<INPUT TYPE=submit name="onhold_final" value=" update onhold reason ">
</FORM>
</CENTER>
<A HREF="#" onClick="window.close()";><B>Close Window</B></A></BODY></HTML>
EOF
exit;
}

########## FINAL ONHOLD EDIT ##########
sub onhold_final {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/) || ($access_level =~ /onhold/)) { &unauth; }
if ($INPUT{'username'} eq "demo") { &unauth; }

$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;


$Account::onhold = $INPUT{'onhold_reason'};

&Account::print_account;

print "<HTML><HEAD><TITLE>$Account::account updated</TITLE><BODY>\n<font face=arial><CENTER>Account: ";
print "<font color=red><B>$Account::account</B></FONT> onhold status updated<BR><BR>\n";
print "<A HREF=\"\#\" onClick=\"window\.close\(\)\"\;><B>Close Window</B></A></BODY></HTML>\n";
exit;
}

######### DELETE POPUP #########
sub delete_pop {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }


$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;

print <<EOF;
<HTML><HEAD><TITLE>$Account::account</TITLE><BODY vlink=blue>
<FORM METHOD=POST ACTION="$cgiurl" name="address">
<input type="Hidden" name="username" value="$username">
<input type="Hidden" name="account" value="$Account::account">
<input type="Hidden" name="cata" value="$Account::cata">
<font face=arial><CENTER>Delete account:
<font color=red><B>$Account::account</B></FONT>
<BR><BR>
<INPUT TYPE=submit name="delete_pop_final" value=" Yes Delete ">
</FORM>
</CENTER>
<A HREF="#" onClick="window.close()";><B>Close Window</B></A></BODY></HTML>
EOF
exit;
}

########### DELETE POP FINAL #########
sub delete_pop_final {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }
if ($INPUT{'username'} eq "demo") { &unauth; }

$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;

&delete_account($Account::account,$Account::cata);

print "<HTML><HEAD><TITLE>$Account::account Deleted</TITLE><BODY>\n<font face=arial><CENTER>Account: ";
print "<font color=red><B>$Account::account</B></FONT> Deleted<BR><BR>\n";
print "<A HREF=\"\#\" onClick=\"window\.close\(\)\"\;><B>Close Window</B></A></BODY></HTML>\n";
exit;

}

###########  DELETE FILES ###########
sub delete_file {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }
if ($INPUT{'username'} eq "demo") { &unauth; }

$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;

%cata_list = &Account::get_cata_hash;

@cata_data = split(/\|/,$cata_list{$Account::cata});
if ($cata_data[0]) { $acc_dir = "$cata_data[0]/$Account::account"; }
else { $acc_dir = $Account::account; }


@files = split(/\,/,$INPUT{'file'});
foreach $file(@files) {
	if ($file =~ /\.\./) { next; }
	$error=0;
	if (-e "$free_path/$acc_dir/$file") {
		unlink("$free_path/$acc_dir/$file") || ($error=1);
		if ($error) {
			$message .= "<font color=red>$file</FONT> - Failed - $!<BR>";			
		}
		else {
			$message .= "<font color=red>$file</FONT> - Deleted<BR>";
		}
	}
	else {
		$message .= "<font color=red>$file</FONT> - Failed - No such file<BR>";
	}
	
}

$dir_acc = "$free_path/$acc_dir";
&space_file_check;
&Account::print_account;

print <<EOF;
<HTML><HEAD><TITLE>$Account::account updated</TITLE><BODY vlink=blue>
<font face=arial><CENTER>Deletion Status for: <font color=red><B>$Account::account</B></FONT>
<BR><BR>$message<BR><BR>
<A HREF="#" onClick="window.close()";><B>Close Window</B></A></BODY></HTML>
EOF
exit;
}

###########  DELETE FOLDERS ###########
sub delete_folder {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }
if ($INPUT{'username'} eq "demo") { &unauth; }

$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;

%cata_list = &Account::get_cata_hash;

@cata_data = split(/\|/,$cata_list{$Account::cata});
if ($cata_data[0]) { $acc_dir = "$cata_data[0]/$Account::account"; }
else { $acc_dir = $Account::account; }


@filep = split(/\,/,$INPUT{'file'});
foreach $filep(@filep) {
	if ($filep =~ /\.\./) { next; }
	$error=0;
	if (-e "$free_path/$acc_dir/$filep") {
		$dir_acc = "$free_path/$acc_dir/$filep";
		&dir_del("$dir_acc");
		rmdir ("$dir_acc") || &error("Failed to remove $dir_acc");
		$message .= "<font color=red>$filep</FONT> - Deleted<BR>";
	}
	else {
		$message .= "<font color=red>$filep</FONT> - Failed - No such Directory<BR>";
	}
	
}

$dir_acc = "$free_path/$acc_dir";
&space_file_check;
&Account::print_account;

print <<EOF;
<HTML><HEAD><TITLE>$Account::account updated</TITLE><BODY vlink=blue>
<font face=arial><CENTER>Deletion Status for: <font color=red><B>$Account::account</B></FONT>
<BR><BR>$message<BR><BR>
<A HREF="#" onClick="window.close()";><B>Close Window</B></A></BODY></HTML>
EOF
exit;
}

######### VIEW DIRECTORY ###########
sub view_dir {

unless (($access_level =~ /ALL ACCESS/) || ($access_level =~ /accounts/)) { &unauth; }

$Account::account = $INPUT{'account'};
$Account::cata = $INPUT{'cata'};

&Account::get_account;

%cata_list = &Account::get_cata_hash;

@cata_data = split(/\|/,$cata_list{$Account::cata});
if ($cata_data[0]) { $acc_dir = "$cata_data[0]/$Account::account"; }
else { $acc_dir = $Account::account; }

print <<EOF;
<HTML><HEAD><TITLE>$Account::account</TITLE><BODY vlink=blue>
<font face=arial size=-1>
<font color=red>$Account::num_files</FONT> files<BR>
<font color=red>$Account::num_dirs</FONT> Directories
<BR><BR>
EOF

undef $/;
open (ACC, "$free_path/$acc_dir/_data/files_hf.txt");
$ffiles = <ACC>;
close (ACC);
$/ = "\n";

@files = split(/\n/,$ffiles);

foreach $file(@files) {
	$url_base = $file;
	$url_base =~ s/$free_path\///;
	$file =~ s/$free_path\/$acc_dir\///;

	@pfile = split(/\//,$file);
	$numfile = @pfile;
	
	$a=0;
	while ($a < $numfile) {
		print "<NOBR>\&nbsp\; \&nbsp\; ";
		$show_file = $pfile[$a];
		$a++;
		
	}
	
	$ftype="folder";
	if ($file =~ /\./) {
		print "\&nbsp\; <IMG SRC=\"$url_to_icons/list.gif\"> ";
		$ftype="file";
	}
	else { 
		print "<IMG SRC=\"$url_to_icons/fold.gif\"> ";
	}
	
print <<EOF;
<A HREF="$url/$url_base" target="browse">$show_file</A>
<SMALL><A HREF="javascript:void(0);" onClick="window.open('$files::browse?username=$INPUT{'username'}&action=delete_$ftype&account=$Account::account&cata=$Account::cata&file=$file','delete','toolbar=no,location=no,directories=no,status=no,width=300,height=150')";>[delete]</A>
</SMALL><BR></NOBR>
EOF

}	

print <<EOF;
<BR><BR><B>
<A HREF="$files::browse?username=$INPUT{'username'}&action=view_dir&account=$Account::account&cata=$Account::cata">Refresh</A>
<BR><BR>
<A HREF="#" onClick="window.close()";><B>Close Window</B></A></BODY></HTML>

EOF
exit;
}

############ CHECK SPACE - LIST FOLDERS FILES ###########
sub space_file_check {

$Account::num_files=0;
$Account::num_dirs=0;

&dir_lists("$dir_acc");

open (ACC, ">$dir_acc/_data/dirs_hf.txt") || &main::error("Error writing directory file");
print ACC $dir_lists;
close (ACC);

open (ACC, ">$dir_acc/_data/files_hf.txt") || &main::error("Error writing directory file");
print ACC $file_lists;
close (ACC);

$Account::size=$total_k;

}

########## DIRECTORY LISTINGS ##########
sub dir_lists {

my $direc = $_[0];
my (@dirs,$new_dir);

opendir(DIR,$direc);
@dirs = grep {!(/^\./) && -d "$direc/$_" } readdir(DIR);
close DIR;
@dirs = sort(@dirs);

opendir (DIR, "$direc");
@files = grep {!(/^\./) && -f "$direc/$_"}  readdir(DIR);
close (DIR); 
@files = sort(@files);

my @parsed_dir = split(/\//,$direc);
@parsed_dir = reverse(@parsed_dir);

my $dir = $parsed_dir[0];

foreach $file(@files) {
	$show_file = $file;
	$show_file =~ s/$dir_acc\///i;
	$file_lists .= "$direc/$file\n";
	$Account::num_files++;

	@stats = stat("$direc/$file");
	$mtime = $stats[9];
	$atime = $stats[8];
	$size = $stats[7];
	$size = $size /1000;
	$total_k = $size + $total_k;
}

	
for $new_dir(0..$#dirs) {
	$show_dir = "$direc/$dirs[$new_dir]";
	$show_dir =~ s/$dir_acc\///i;
	unless ($main::bad_dirs{$show_dir}) {
		$file_lists .= "$direc/$dirs[$new_dir]\n";
		$dir_lists .= "$show_dir\n";
		$Account::num_dirs++;
		&dir_lists("$direc/$dirs[$new_dir]",$blank);
	}

}


}

########## DELETE SLECTED FILES #########
sub del_select {


&Header(4);

print <<EOF;
<CENTER>
$css_font
The following Accounts were deleted:<BR><BR>
<font color=red><B>

EOF


while ( ($key, $value) = each(%INPUT) ) {

	if ($key =~ /^accdel_/) {
		$key =~ s/^accdel_//;
		@dels = split(/\|/,$key);
		unless ($dels[1]) { $dels[1]="accounts"; }
		
		if ($dels[0]) { 
			&delete_account($dels[0],$dels[1]);		
			print "$dels[0]<BR>";
		}
	}
}

print <<EOF;
</B></FONT><BR><BR>
EOF
&Footer;
exit;
}


########### DELETE ACCOUNT ##########
sub del {

unless ($INPUT{'cata'}) { $INPUT{'cata'} = "accounts"; }

&delete_account($INPUT{'account'},$INPUT{'cata'});

&Header(4);

print <<EOF;
<CENTER>
$css_font
Account: <FONT COLOR=reD><B>$INPUT{'account'}</B></FONT>
Deleted
<BR><BR>
EOF

&Footer;
exit;
}

########## ACTUAL DELETION OF ACCOUNT #########
sub delete_account {

if ($INPUT{'username'} eq "demo") { &unauth; }

$Account::account = $_[0];
$Account::cata = $_[1];

my $acc_test = &Account::get_account;
unless ($acc_test) {
	&error("Could find account - $Account::account in category - $Account::cata");
}

%cata_list = &Account::get_cata_hash;

@cata_data = split(/\|/,$cata_list{$Account::cata});
if ($cata_data[0]) { $acc_dir = "$cata_data[0]/$Account::account"; }
else { $acc_dir = $Account::account; }

$dir_acc = "$free_path/$acc_dir";

&dir_del("$dir_acc");
rmdir ("$dir_acc") || &error("Failed to remove $dir_acc");

&Account::delete_account;
&Account::cate_increment($Account::cata,0);

}

########## DIR DEL ##########
sub dir_del {



my $direc = $_[0];
my (@dirs,$new_dir);

opendir(DIR,$direc);
@dirs = grep {!(/^\./) && -d "$direc/$_" } readdir(DIR);
close DIR;
@dirs = sort(@dirs);

opendir (DIR, "$direc");
@files = grep {!(/^\./) && -f "$direc/$_"}  readdir(DIR);
close (DIR); 

foreach $file(@files) {
	unlink("$direc/$file") || &error("Failed to remove $direc/$file");
}

for $new_dir(0..$#dirs) {
	&dir_del("$direc/$dirs[$new_dir]");
	rmdir("$direc/$dirs[$new_dir]") || &error("Failed to remove $direc/$dirs[$new_dir]");
}

}


sub sort_hasp {
	my $x = shift;
	my %array = %$x;
	if ($INPUT{'asc_dec'} eq "asc") {
		sort { $array{$a} cmp $array{$b}; } keys %array;
	}
	else {
		sort { $array{$b} cmp $array{$a}; } keys %array;
	}

}

sub sort_hashs {
	my $x = shift;
	my %array = %$x;
	if ($INPUT{'asc_dec'} eq "asc") {
		sort { $array{$a} <=> $array{$b}; } keys %array;
	}
	else {
		sort { $array{$b} <=> $array{$a}; } keys %array;	
	}

}

1;


