#!/usr/bin/perl

##############################################
#                Please Edit                 #
##############################################
# requires the absolute, or relative path and 
# and file name of file.pl
require "file.pl";

##############################################
#                   Done!                    #
##############################################


# seed the random number generator (you can add args to make more robust)
srand;

# retrieve the list of links and data
&open_links;

foreach $link (@links) {
	for $i (1 .. $weight{$link}) {
		push (@current_links, $link);
	}
}

while ( (@current_links) ne 0 ) {
	$current_account = int(rand(@current_links));
	$link = @current_links[$current_account];
	if ( int($clicks_left{$link}) >= 1 ) {
		print ("Location: ", $url{$link}, "\n\n");
		$clicks{$link}++;
		$clicks_left{$link}--;
		&write_links;
		exit;
	}	
	@current_links = &removeElements($link, @current_links);
}

&close_links;
print ("Location: ", $default_link, "\n\n");
exit;


sub removeElements {
	my ($element, @list) = @_;
	my @new_list;
	foreach $i (@list) {
		if ($i ne $element) {
			push (@new_list, $i);
		}
	}
	return (@new_list);
}