<?

if ($screen == "view") {
// ---------------------------------------------------------------------------
// the view screen will either store a new entry or retrieve an existing entry

	$image_entry = new image;

// put vars into object
	if (isset($_REQUEST["id"])) {
		$image_entry->id = $_REQUEST["id"];
	}
	if (isset($_REQUEST["title"])) {
		$image_entry->title = $_REQUEST["title"];
	}
	if (isset($_REQUEST["description"])) {
		$image_entry->description = $_REQUEST["description"];
	}
	if (isset($_REQUEST["keywords"])) {
		$image_entry->keywords = $_REQUEST["keywords"];
	}
	if (isset($_REQUEST["people"])) {
		$image_entry->people = $_REQUEST["people"];
	}
	if (isset($_REQUEST["event"])) {
		$image_entry->event = $_REQUEST["event"];
	}
	if (isset($_REQUEST["location"])) {
		$image_entry->location = $_REQUEST["location"];
	}
	if (isset($_REQUEST["state"])) {
		$image_entry->state = $_REQUEST["state"];
	}
	if (isset($_REQUEST["country"])) {
		$image_entry->country = $_REQUEST["country"];
	}
	if (isset($_REQUEST["indoors"])) {
		$image_entry->indoors = $_REQUEST["indoors"];
	}
	if (isset($_REQUEST["URL"])) {
		$image_entry->URL = $_REQUEST["URL"];
	}
	if (isset($_REQUEST["datetaken"])) {
		$image_entry->datetaken = $_REQUEST["datetaken"];
	}
	if (isset($_REQUEST["portfolio"])) {
		$image_entry->portfolio = $_REQUEST["portfolio"];
	}
	$image_entry->needdetails = 0;

// check what to do - insert or update	
	if (empty ($image_entry->id)) {
// create thumbnail to put in the database
		$image_entry->thumbnail = $image_entry->create_thumbnail();
// get orientation of photo
		$image_entry->orientation = $image_entry->get_orientation();
// check to see if URL is already in the database
		$test = is_in_database('URL',$image_entry->URL);
		if ($test == true) {
			$msg_error[] = "<b>WARNING:</b> an entry with URL: ".$image_entry->URL." is already in the database.";
		}
// put new image in the database
		$image_entry->store();
// get ID of inserted photo
		$image_entry->id = mysql_insert_id();
// remove slashes before displaying
		$image_entry = $image_entry->clean();		
	}
	elseif ((!empty ($image_entry->id)) && ($action == "update")) {
// get orientation of photo
		$image_entry->orientation = $image_entry->get_orientation();
// update image in the database
		$image_entry->update();
	}
// get existing image from the database
	$image_exists = is_in_database('ID', $image_entry->id);
	if ($image_exists == true) {
		$image_entry = $image_entry->retrieve($image_entry->id);
		$image_entry = $image_entry->convert_quotes_to_HTML();
		if ($custom->minimize_data_transfer == 1) {
			$temp_file_name = "temp_display_img_".$image_entry->id;
			$temp = "temp/".$temp_file_name.".jpg";
			$temp = file_exists($temp);
			if ($temp == false) {
				$image_entry->display_URL = save_JPEG_file_from_JPEG($image_entry->URL, 800, "temp/", $temp_file_name, 70);
			}
			else {
				$image_entry->display_URL = "temp/".$temp_file_name.".jpg";
			}
		}
		else {
			$image_entry->display_URL = str_replace(" ", "%20", $image_entry->URL);
		}
// get preview dimensions
		$preview_dimensions = get_preview_dimensions($image_entry->display_URL);
	}
	else {
		$msg_error[] = "<b>ERROR:</b> No photo entry of ID #".$id;
		$show_body = 0;
		$show_image = 0;
	}
// set the screen type
	$body = "view.php";
}
elseif ($screen == "search") {
// ---------------------------------------------------------------------------
// search form for entering search criteria
	$init_string = $init_string." setFocus();";
// delete temp images
	clean_up_temp_dir();
// set the screen type
	$body = "search.php";
	$show_image = 0;
}
elseif ($screen == "list") {
// ---------------------------------------------------------------------------
// return a list of images matching a query

	$images = new image_list;
	
	if (isset($_REQUEST["items_per_page"])) {
		$images->show_n = $_REQUEST["items_per_page"];
	}
	if (isset($_REQUEST["result_view"])) {
		$result_view = $_REQUEST["result_view"];
	}
	else {
		$result_view = "thumbnail";
	}
	
	if (empty($nav_command)) {
		if (isset($action) && $action == "get_last_15") {
			$result_view = "thumbnail";
			$images->show_n = 15;
			
			$query = "SELECT ID FROM images ORDER BY ID DESC LIMIT 15"; 
			$result = mysql_query($query)
					or die("error: ".mysql_error());
	
			$images->items = array();
			$images->items_string = "";
			
			while (list($id) = mysql_fetch_array($result)) {
				$images->items[] = $id;
			}
			sort($images->items, SORT_NUMERIC);
// get last 15, or fewer if not 15 photos
			if (count($images->items) < 15) {
				$max = count($images->items);
			}
			else {
				$max = 15;
			} 
			for ($i = 0; $i < $max; $i++) {
				$images->items_string = $images->items_string.$images->items[$i].",";
			}			
		}
		else {
// we need to find matching images
// build query string criteria
			$query = "";
			$query = query_add_property($query, 'orientation', $_REQUEST["orientation"], '=', '');
			$query = query_add_property($query, 'needdetails', $_REQUEST["needdetails"], '=', '');
			$query = query_add_property($query, 'portfolio', $_REQUEST["portfolio"], '=', '');
			$query = query_add_property($query, 'ID', $_REQUEST["id"], '=', '');
			$query = query_add_property_array($query, 'title', $_REQUEST["title"], 'AND');
			$query = query_add_property_array($query, 'description', $_REQUEST["description"], 'AND');
			$query = query_add_property_array($query, 'keywords', $_REQUEST["keywords"], 'AND');
			$query = query_add_property_array($query, 'people', $_REQUEST["people"], 'AND');
			$query = query_add_property_array($query, 'event', $_REQUEST["event"], 'AND');
			$query = query_add_property_array($query, 'location', $_REQUEST["location"], 'AND');
			$query = query_add_property($query, 'state', $_REQUEST["state"]);
			$query = query_add_property($query, 'country', $_REQUEST["country"]);
			$query = query_add_property($query, 'indoors', $_REQUEST["indoors"]);
			$query = query_add_property($query, 'URL', $_REQUEST["URL"]);
			$query = query_add_date_range_property($query, 'datetaken', $_REQUEST["datetaken_from_month"], $_REQUEST["datetaken_from_day"], $_REQUEST["datetaken_from_year"], ">=");
			$query = query_add_date_range_property($query, 'datetaken', $_REQUEST["datetaken_to_month"], $_REQUEST["datetaken_to_day"], $_REQUEST["datetaken_to_year"], "<=");
	
// get all photos if no query data entered
			if ($query == "") {
				$query = query_add_property_array($query, 'title', "%", 'AND');
			}
			
			$query = "SELECT ID FROM images WHERE ( ".$query." ) ORDER BY datetaken, ID";
			$results = mysql_query($query)
					or die("error: ".mysql_error());
	
			$images->items = array();
			$images->items_string = "";
			
			while (list($id) = mysql_fetch_array($results)) {
				$images->items[] = $id;
				$images->items_string = $images->items_string.$id.",";
			}
		}
		
		$images->items_string = substr($images->items_string, 0, -1);
		$images->count = count($images->items);

		if ($debug == 1) { 
			print("<p>Select by Search Criteria Query: <span class=\"code\">".$query."</span>"); 
			print("<p>\$images->items_string: <span class=\"code\">".$images->items_string."</span>"); 
			print("<p>\$images->count: <span class=\"code\">".$images->count."</span>"); 
			print("<p>\$images->items: <span class=\"code\">");
				print_r(array_values($images->items));
				print("</span>"); 
			print("<p>\$images->position: <span class=\"code\">".$images->position."</span>"); 
		}
	}
	elseif (!empty($nav_command)) {
// we already have our list of images, need to move around the list
		$images = $images->set_defaults($_REQUEST["list_items"]);
		$images->position = $_REQUEST["position"];
		
		$images = $images->navigate($nav_command);
	}

	$images->items_shown = $images->get_items_shown();

// set the screen type
	$body = "list.php";
}
elseif ($screen == "portfolio") {
// ---------------------------------------------------------------------------
// return a list of images flagged as "portfolio" shots

	$images = new image_list;
	$images->show_n = 9;
	$result_view = "contact_sheet";

	if (empty($nav_command)) {
		$query = "SELECT ID FROM images WHERE ( portfolio = '1' ) ORDER BY datetaken";

		$results = mysql_query($query)
				or die("error: ".mysql_error());

		$images->items = array();
		$images->items_string = "";
		
		while (list($id) = mysql_fetch_array($results)) {
			$images->items[] = $id;
			$images->items_string = $images->items_string.$id.",";
		}
		$images->items_string = substr($images->items_string, 0, -1);
		$images->count = count($images->items);

		if ($debug == 1) { 
			print("<p>Select by Search Criteria Query: <span class=\"code\">".$query."</span>"); 
			print("<p>\$images->items_string: <span class=\"code\">".$images->items_string."</span>"); 
			print("<p>\$images->count: <span class=\"code\">".$images->count."</span>"); 
			print("<p>\$images->items: <span class=\"code\">");
				print_r(array_values($images->items));
				print("</span>"); 
			print("<p>\$images->position: <span class=\"code\">".$images->position."</span>"); 
		}
	}
	elseif (!empty($nav_command)) {
// we already have our list of images, need to move around the list
		$images = $images->set_defaults($_REQUEST["list_items"]);
		$images->position = $_REQUEST["position"];
		
		$images = $images->navigate($nav_command);
	}

	$images->items_shown = $images->get_items_shown();

// set the screen type
	$body = "list.php";
}
elseif ($screen == "entry") {
// ---------------------------------------------------------------------------
// show entry/edit form

	$image_entry = new image;

// get quick entry data
	if (isset($entry_shortcut_id)) {
		$image_entry->URL = $_REQUEST["shortcut_cleanURL"];
		$image_entry->datetaken = $_REQUEST["shortcut_datetaken"];
		$entry_shortcut_data_retrieved = new image;
		$entry_shortcut_data_retrieved = get_copy_entry_values($entry_shortcut_id);
	}
	$entry_shortcut_data_last = new image;
	$entry_shortcut_data_last = get_copy_entry_values();

	if (isset($action) && $action == "add_details") {
		$query = "SELECT ID FROM images WHERE needdetails = 1 ORDER BY datetaken, ID";
		$temp = mysql_query($query);
		$i = 0;
		while (list($fetched_id) = mysql_fetch_row($temp)) {
			if ($i < 1) {
				$id = $fetched_id;
			}
			$i++;
		}
		if (empty($id)) {
			$init_string = " alert('No photos need details added.');";
		}
	}

	if (empty($id)) {
// set default varibles
		$image_entry->country = $custom->entry_country;
		$image_entry->state = $custom->entry_state;
// load image and set up variables that can automatically be entered
		if (isset($action) && $action == "load_image") {
			$image_entry->datetaken = $image_entry->get_datetaken($cleanURL);
			$image_entry->orientation = $image_entry->get_orientation();
		}
		if (empty($image_entry->URL)) {
			$image_entry->URL = $cleanURL;
		}
// check to see if URL is already in the database
		$test = is_in_database('URL',$image_entry->URL);
		if ($test == true) {
			$msg_error[] = "<b>WARNING:</b> an entry with URL: ".$image_entry->URL." is already in the database.";
		}
		$unique = get_unique_id();
		$temp_file_name = "temp_display_img_".$unique;
	}
	else {
// get existing image from the database
		$image_exists = is_in_database('ID', $id);
		if ($image_exists == true) {
			$image_entry = $image_entry->retrieve($id);
			$image_entry = $image_entry->convert_quotes_to_HTML();
			$temp_file_name = "temp_display_img_".$image_entry->id;
		}
		else {
			$msg_error[] = "<b>ERROR:</b> No photo entry of ID #".$id;
			$show_body = 0;
			$show_image = 0;
		}
	}
	if ($custom->minimize_data_transfer == 1) {
		$temp = "temp/".$temp_file_name.".jpg";
		$temp = file_exists($temp);
		if ($temp == false) {
			$image_entry->display_URL = save_JPEG_file_from_JPEG($image_entry->URL, 800, "temp/", $temp_file_name, 70);
		}
		else {
			$image_entry->display_URL = "temp/".$temp_file_name.".jpg";
		}
	}
	else {
		$image_entry->display_URL = str_replace(" ", "%20", $image_entry->URL);
	}
// get preview dimensions
	$preview_dimensions = get_preview_dimensions($image_entry->display_URL);
// set the screen type
	$body = "entry.php";
	$init_string = $init_string." setFocus();";
}
elseif ($screen == "load_folder") {
// ---------------------------------------------------------------------------
// the load_folder screen will allow you to specify a folder to grab images from

	$show_image = 0;
	if (isset($_REQUEST["path"])) {
		$path = $_REQUEST["path"];
	}
	
	$photo_URLs = array();
	
	if (isset($path) && $action == "check_path") {
		if (is_dir($path)) {
			$photo_URLs = load_photos($path);
		}

		for ($i = 0; $i < count($photo_URLs); $i++) {
			$test = is_in_database('URL',$photo_URLs[$i]);
			if ($test == true) {
				$msg_error[] = "<b>WARNING:</b> an entry with URL: ".$photo_URLs[$i]." is already in the database.";
			}
		}
// set defaults
		$image_entry->country = $custom->entry_country;
		$image_entry->state = $custom->entry_state;
		
		$unique = get_unique_id();
// create thumbnail images for each $photo_URLs
		for ($i = 0; $i < count($photo_URLs); $i++) {
			$filename = "load_folder_thumb_".$unique."_".$i;
			save_JPEG_file_from_JPEG($photo_URLs[$i], 160, "temp/", $filename);
		}

		if ($debug == 1) {
			print_r(array_values($photo_URLs));
		}
		$init_string = $init_string." setFocus();";
	}
	elseif (isset($path) && $action == "store_images") {
	
		$image_entry = new image;
	
// put vars into object
//		$image_entry->id = $_REQUEST["id"];						// id not created yet
		$image_entry->title = $_REQUEST["title"];
		$image_entry->description = $_REQUEST["description"];
		$image_entry->keywords = $_REQUEST["keywords"];
		$image_entry->people = $_REQUEST["people"];
		$image_entry->event = $_REQUEST["event"];
		$image_entry->location = $_REQUEST["location"];
		$image_entry->state = $_REQUEST["state"];
		$image_entry->country = $_REQUEST["country"];
		$image_entry->indoors = $_REQUEST["indoors"];
//		$image_entry->URL = $_REQUEST["URL"];					// value taken from $photo_URLs
//		$image_entry->datetaken = $_REQUEST["datetaken"];		// value grabbed from exif data or left blank
		if (isset($_REQUEST["needdetails"])) {
			$image_entry->needdetails = $_REQUEST["needdetails"];
		}
		else {
			$image_entry->needdetails = 0;
		}
		$image_entry->portfolio = 0;
	
		$photo_URLs = array();
	
		$photo_URLs = load_photos($path);
		
		if ($debug == 1) {
			print_r(array_values($photo_URLs));
		}

// get date from each photo
		for ($i = 0; $i < count($photo_URLs); $i++) {
			$image_entry->URL = $photo_URLs[$i];
			$image_entry->datetaken = $image_entry->get_datetaken();
			$image_entry->thumbnail = $image_entry->create_thumbnail();
			$image_entry->orientation = $image_entry->get_orientation();

			$test = is_in_database('URL',$image_entry->URL);
			if ($test == true) {
				$msg_error[] = "<b>WARNING:</b> an entry with URL: ".$image_entry->URL." is already in the database.";
			}

			$image_entry->store();
		}
	}


// set the screen type
	$body = "load_folder.php";
}
elseif ($screen == "confirm") {
// ---------------------------------------------------------------------------
// the confirm screen will either delete an entry
	$msg_confirm = "";
	if (!empty($id) && ($action == "delete" || $action == "delete_file")) {
		if ($action == "delete_file") { // delete file
			$temp_image = new image;
			$temp_image = $temp_image->retrieve($id);
// delete specified image file
			$temp = @unlink($temp_image->URL);
			if ($temp == true) {
				$msg_confirm = $msg_confirm."<p>Photo ".$temp_image->URL." has been deleted from the hard drive.\n";
			}
			else {
				$msg_confirm = $msg_confirm."<p>Error deleting ".$temp_image->URL." from the hard drive.\n";
			}
		}
// delete image from database
		$query = "DELETE FROM images WHERE ID = '$id'";
		mysql_query($query)
			or die("error: ".mysql_error());
// set confirm message
		$msg_confirm = $msg_confirm."<p>Photo record #".$id." has been deleted from the database.\n";
	}
	else {
		$msg_confirm = $msg_confirm."Didn't do anything.";
	}
// set the screen type
	$body = "confirm.php";
	$show_image = 0;
}
elseif ($screen == "about") {
// ---------------------------------------------------------------------------
// the about screen shows info about this application
// set the screen type
	$body = "about.php";
	$show_image = 0;
}
else {
// ---------------------------------------------------------------------------
// show search form
	$init_string = $init_string." setFocus();";
	$body = "search.php";
	$show_image = 0;
}

?>