function setURL() {
	url = document.loadImageForm.URLfile.value;
	if (url.indexOf('\\')) { // check to swap slashes for backslashes if on a Windows server
		pattern = /\\/g;
		url = url.replace(pattern,'\/');
	}
// swap %20 for space
//	url = url.replace(/\s/g,"%20");
	url_index = url.lastIndexOf('gallery_photos/');
	url = url.slice(url_index);
	document.loadImageForm.cleanURL.value = url;
}

function toggleCheckbox(thisCheckbox) {
	if (thisCheckbox.checked == true) {
		thisCheckbox.checked = false;
	}
	else {
		thisCheckbox.checked = true;
	}
}

function setCopyEntryValueType(radioValue) {
	radioArray = document.entryShortcutForm.entry_shortcut_type;
	for (i = 0; radioArray[i]; i++) {
		if (radioArray[i].value == radioValue) {
			radioArray[i].checked = true;
		}
	}
}

function setSelectToValue(thisSelect, thisValue) {
	for (i = 0; thisSelect[i]; i++) {
		if (thisSelect[i].value == thisValue) {
			thisSelect[i].selected = true;
		}
	}
}

function getSelectOptionOfThisValue(thisSelect, thisValue) { // select the specified option
	success = 0;
	for (i = 0; thisSelect[i]; i++) {
		if (thisSelect[i].value == thisValue) {
			success = 1;
			return i;
		}
	}
	if (success == 0) {
		return false;
	}
}

function copyEntryData(type) { // fill the entry fields with the previously entered image data

	if (type == "detect") {
		radioArray = document.entryShortcutForm.entry_shortcut_type;
		for (i = 0; radioArray[i]; i++) {
			if (radioArray[i].checked == true) {
				type = radioArray[i].value;
			}
		}
	}
	
	if (type == "last") {
		document.imageForm.title.value = document.entryShortcutFormData.last_title.value;
		document.imageForm.description.value = document.entryShortcutFormData.last_description.value;
		document.imageForm.keywords.value = document.entryShortcutFormData.last_keywords.value;
		document.imageForm.people.value = document.entryShortcutFormData.last_people.value;
		document.imageForm.event.value = document.entryShortcutFormData.last_event.value;
		if (document.entryShortcutFormData.last_indoors.value != "") {
			setSelectToValue(document.imageForm.indoors, document.entryShortcutFormData.last_indoors.value);
		}
		document.imageForm.location.value = document.entryShortcutFormData.last_location.value;
		document.imageForm.state.value = document.entryShortcutFormData.last_state.value;
		document.imageForm.country.value = document.entryShortcutFormData.last_country.value;
		
		setFocus();
	}
	else if (type == "retrieved") {
		document.imageForm.title.value = document.entryShortcutFormData.retrieved_title.value;
		document.imageForm.description.value = document.entryShortcutFormData.retrieved_description.value;
		document.imageForm.keywords.value = document.entryShortcutFormData.retrieved_keywords.value;
		document.imageForm.people.value = document.entryShortcutFormData.retrieved_people.value;
		document.imageForm.event.value = document.entryShortcutFormData.retrieved_event.value;
		if (document.entryShortcutFormData.retrieved_indoors.value != "") {
			setSelectToValue(document.imageForm.indoors, document.entryShortcutFormData.retrieved_indoors.value);
		}
		document.imageForm.location.value = document.entryShortcutFormData.retrieved_location.value;
		document.imageForm.state.value = document.entryShortcutFormData.retrieved_state.value;
		document.imageForm.country.value = document.entryShortcutFormData.retrieved_country.value;
		
		setFocus();
	}
	else if (type == "id") {
		if (document.entryShortcutForm.entry_shortcut_id.value == '') {
			alert('Enter the ID of the Photo you want to copy data from.');
			document.entryShortcutForm.entry_shortcut_id.focus();
			return;
		}
		document.entryShortcutForm.shortcut_cleanURL.value = document.imageForm.URL.value;
		document.entryShortcutForm.shortcut_datetaken.value = document.all.imageForm.datetaken.value;

		entryShortcutForm.submit();
	}
}

function navigateList(command) { 
	document.listControlForm.nav_command.value = command;
	document.listControlForm.submit();
}

function clearEntryData() {
	document.imageForm.title.value = "";
	document.imageForm.description.value = "";
	document.imageForm.keywords.value = "";
	document.imageForm.people.value = "";
	document.imageForm.event.value = "";
	setSelectToValue(document.imageForm.indoors, "");
	document.imageForm.location.value = "";
	document.imageForm.state.value = "";
	document.imageForm.country.value = "";
}

function clearSearchData() {
	setSelectToValue(document.imageForm.orientation, "");
	setSelectToValue(document.imageForm.needdetails, "");
	setSelectToValue(document.imageForm.portfolio, "");
	document.imageForm.title.value = "";
	document.imageForm.id.value = "";
	document.imageForm.description.value = "";
	document.imageForm.keywords.value = "";
	document.imageForm.people.value = "";
	document.imageForm.event.value = "";
	setSelectToValue(document.imageForm.indoors, "");
	document.imageForm.location.value = "";
	setSelectToValue(document.imageForm.state, "");
	setSelectToValue(document.imageForm.country, "");
	document.imageForm.URL.value = "";
	setDateDropDowns('clear', document.imageForm.datetaken_from_month, document.imageForm.datetaken_from_day, document.imageForm.datetaken_from_year);
	setDateDropDowns('clear', document.imageForm.datetaken_to_month, document.imageForm.datetaken_to_day, document.imageForm.datetaken_to_year);
}

function sizeImg(newWidth, newHeight, imgToSize) {
	imgToSize = "imgToSize = document." + imgToSize + ";";
	eval(imgToSize)
	imgToSize.style.width = newWidth;
	imgToSize.style.height = newHeight;
}

function previewImage(url, orientation) {
	viewImg.src = url;
	
	if (!orientation || orientation == 0) {
		sizeImg('320', '213', 'viewImg');
	}
	else {
		sizeImg('213', '320', 'viewImg');
	}
}

function confirmDelete() {
	toggleDiv('delete');
}

function confirmDeleteFile() {
	if (document.getElementById('delete_file_checkbox') && document.getElementById('delete_file_checkbox').checked == true) {
		toggleDiv('delete');
		toggleDiv('delete_file');
		
		return true;
	}
	else {
		return false;
	}
}

function setFocus() {
	if (document.imageForm && document.imageForm.title) {
		document.imageForm.title.focus();
	}
}

function showLoadFolderThumb(imgURL) {
	loadFolderThumb.src = imgURL;
}

function toggleDiv(divName) {
	thisDiv = document.getElementById(divName);
	if (thisDiv) {
		if (thisDiv.style.display == "none") {
			thisDiv.style.display = "block";
		}
		else {
			thisDiv.style.display = "none";
		}
	}
	else {
		errorString = "Error: Could not locate div with id: " + divName;
		alert(errorString);
	}
}

function validateData() {
	thisDate = document.imageForm.datetaken.value;
	if (thisDate != "") { // date is set
		firstDash = thisDate.indexOf("-");
		secondDash = thisDate.lastIndexOf("-");
		thisLength = thisDate.length;
		if (firstDash == 4 && secondDash == 7 && thisDate.length == 10) {
			return true;
		}
		else {
			alert("The 'Date Taken' field is not properly formatted as 'YYYY-MM-DD'.");
			return false;
		}
	}
	else { // date isn't set
		return true;
	}
}

function validateSearchData() {
	fromDay = document.imageForm.datetaken_from_day.value;
	fromMonth = document.imageForm.datetaken_from_month.value;
	fromYear = document.imageForm.datetaken_from_year.value;
	toDay = document.imageForm.datetaken_to_day.value;
	toMonth = document.imageForm.datetaken_to_month.value;
	toYear = document.imageForm.datetaken_to_year.value;
	if ((fromYear > toYear) || (fromYear == toYear && fromMonth > toMonth) || (fromYear == toYear && fromMonth == toMonth && fromDay > toDay)) {
		alert('There is a problem with the specified Date Taken range. Please fix it and try your search again.');
		return false;
	}
	else { // date range is ok
		return true;
	}
}

function hideMenu() {
	if (displayedMenu != "") {
		document.getElementById(displayedMenu).style.display = "none";
		displayedMenu = "";
	}
}

function showMenu(menuID, menuImage) {
	if (displayedMenu != "" && displayedMenu != menuID) {
		hideMenu();
	}
	displayedMenu = menuID;
	if (document.getElementById(displayedMenu).style.display == "block") { // hide menu if already visible
		hideMenu();
	}
	else { // show menu
		document.getElementById(displayedMenu).style.display = "block";
		document.getElementById(displayedMenu).style.top = menuImage.offsetHeight;
		event.cancelBubble = true;
	}
}

function highlightMenuItem(thisDiv) {
	if (thisDiv.className == "popupMenuItemOn") {
		thisDiv.className = "popupMenuItem";
	}
	else {
		thisDiv.className = "popupMenuItemOn";
	}
}

function setDateDropDowns(action, selMonth, selDay, selYear) {
	if (action == "today") {
		setSelectToValue(selMonth, currentMonth);
		setSelectToValue(selDay, currentDay);
		setSelectToValue(selYear, currentYear);
	}
	else if (action == "clear") {
		setSelectToValue(selMonth, "");
		setSelectToValue(selDay, "");
		setSelectToValue(selYear, "");
	}
}

