<?

class image {

/*******************************************************************
	* class image
	*
	* Methods:
	*	image() - initialize variables
	*	clean() - removes slashes, returns image
	*	store() - insert new image in database
	*	update($thumbnail = 0) - if $thumbnail = 1, create new thumbnail for the image and include it in the update 
	*	retrieve($id = $this->$id) - retrieve an image, returns image w/ all properties
	*	create_thumbnail($URL = $this->URL, $size = 160) - create a thumbnail, returns $thumbnail
	*	get_orientation($URL = $this->URL) - is photo vertical (1) or horizontal (0)
	*
	*/
	
	var $id;
	var $title;
	var $description;
	var $keywords;
	var $people;
	var $event;
	var $indoors;
	var $location;
	var $state;
	var $country;
	var $URL;
	var $datetaken;
	var $thumbnail;
	var $needdetails;
	var $portfolio;
	var $orientation;
	var $display_URL;			// used to display temp image

	function image() { // intializes variables
		$this->id = "";
		$this->title = "";
		$this->description = "";
		$this->keywords = "";
		$this->people = "";
		$this->event = "";
		$this->location = "";
		$this->state = "";
		$this->country = "";
		$this->indoors = "";
		$this->URL = "";
		$this->datetaken = "";
		$this->thumbnail = "";
		$this->needdetails = 0;
		$this->portfolio = 0;
		$this->orientation = 0;
		$this->display_URL = "";
	}
	
	function clean() { // removes slashes from text values
		$this->title = stripslashes($this->title);
		$this->description = stripslashes($this->description);
		$this->keywords = stripslashes($this->keywords);
		$this->people = stripslashes($this->people);
		$this->event = stripslashes($this->event);
		$this->location = stripslashes($this->location);
		$this->state = stripslashes($this->state);
		
		return $this;
	}

	function add_slashes() { // add slashes to text values
		$this->title = addslashes($this->title);
		$this->description = addslashes($this->description);
		$this->keywords = addslashes($this->keywords);
		$this->people = addslashes($this->people);
		$this->event = addslashes($this->event);
		$this->location = addslashes($this->location);
		$this->state = addslashes($this->state);
		
		return $this;
	}

	function convert_quotes_to_HTML() { // add slashes to text values
		$this->title = str_replace("\"", "&quot;", $this->title);
		$this->description = str_replace("\"", "&quot;", $this->description);
		$this->keywords = str_replace("\"", "&quot;", $this->keywords);
		$this->people = str_replace("\"", "&quot;", $this->people);
		$this->event = str_replace("\"", "&quot;", $this->event);
		$this->location = str_replace("\"", "&quot;", $this->location);
		$this->state = str_replace("\"", "&quot;", $this->state);
		
		return $this;
	}

	function store() { // inserts a new image into the database
    	$query = "INSERT into images ( title, description, keywords, people, event, location, state, country, indoors, URL, datetaken, thumbnail, needdetails, portfolio, orientation ) values ( '$this->title', '$this->description', '$this->keywords', '$this->people', '$this->event', '$this->location', '$this->state', '$this->country', '$this->indoors', '$this->URL', '$this->datetaken', '$this->thumbnail', '$this->needdetails', '$this->portfolio', '$this->orientation')";
		mysql_query($query)
		or die("error: ".mysql_error());
	}
	
	function update($thumbnail = 0) { // updates an existing image
		if ($thumbnail == 1) {
			$this->thumbnail = $this->create_thumbnail();
			$query = "UPDATE images set title='$this->title', description='$this->description', keywords='$this->keywords', people='$this->people', event='$this->event', location='$this->location', state='$this->state', country='$this->country', indoors='$this->indoors', URL='$this->URL', datetaken='$this->datetaken', thumbnail='$this->thumbnail', needdetails='$this->needdetails', portfolio='$this->portfolio', orientation='$this->orientation' WHERE ID = '$this->id'";
		}
		else {
			$query = "UPDATE images set title='$this->title', description='$this->description', keywords='$this->keywords', people='$this->people', event='$this->event', location='$this->location', state='$this->state', country='$this->country', indoors='$this->indoors', URL='$this->URL', datetaken='$this->datetaken', needdetails='$this->needdetails', portfolio='$this->portfolio', orientation='$this->orientation' WHERE ID = '$this->id'";
		}
		mysql_query($query)
			or die("error: ".mysql_error());
	}
	
	function retrieve($id = "") {
		if ($id == "") {
			$id = $this->id;
		}
		else {
			$this->id = $id;
		}
		$query = "SELECT * FROM images WHERE ID = '$id'";
		$get_image = mysql_query($query)
			or die("error: ".mysql_error());
		$image = mysql_fetch_row($get_image);
// set variables
		$this->id = $image[0];
		$this->title = $image[1];
		$this->description = $image[2];
		$this->keywords = $image[3];
		$this->people = $image[4];
		$this->event = $image[5];
		$this->location = $image[6];
		$this->state = $image[7];
		$this->country = $image[8];
		$this->indoors = $image[9];
		$this->URL = $image[10];
		$this->thumbnail = $image[11];
		$this->datetaken = $image[12];
		$this->dateentered = $image[13];
		$this->needdetails = $image[14];
		$this->portfolio = $image[15];
		$this->orientation = $image[16];
		
		$this = $this->clean();
		
		return $this;
	}
	
	function create_thumbnail($URL = "", $size = 160) {
		if ($URL == "") {
			$URL = $this->URL;
		}
		
		$temp_image = save_JPEG_file_from_JPEG($URL);

		$thumbnail = fread(fopen($temp_image, "r"), filesize($temp_image));
		unlink($temp_image);

		$thumbnail = addslashes($thumbnail); 
		
		return $thumbnail;
	}

	function get_orientation($URL = "") {
		if ($URL == "") {
			$URL = $this->URL;
		}
		$original = @imagecreatefromJPEG($URL);
		if (!$original) {
			return false;
		}
		else {
	// resize image
			if (imagesx($original) > imagesy($original)) {
				$orientation = 0;
			}
			else {
				$orientation = 1;
			}
		}
		return $orientation;
	}
	
	function get_datetaken($URL = "") {
		if ($URL == "") {
			$URL = $this->URL;
		}
		$exif = read_exif_data_quick($URL);
		while(list($k,$v) = each($exif)) {
			if (is_string($k) && $k == "DateTimeOriginal" && $datefound == 0) {
				$img_year = substr($v, 0, 4);
				$img_month = substr($v, 5, 2);
				$img_day = substr($v, 8, 2);
				$img_hour = substr($v, 11, 2);
				$img_minute = substr($v, 14, 2);
				$img_second = substr($v, 17, 2);
				$datetaken = $img_year."-".$img_month."-".$img_day;
			}
		}
		if (isset($datetaken)) {
			return $datetaken;
		}
		else {
			return false;
		}
	}

}

class image_list {

/*******************************************************************
	* class image_list
	*
	* Methods:
	*	image_list() - initialize variables
	*	set_defaults() - initialize variables
	*
	*/

	var $items;						// array of item id's
	var $items_string;				// comma delimited string of id's
	var $count;						// number of items in list - I don't think I need this
	var $position;					// begin list at this number
	var $show_n;					// show n number of items in list
	var $items_shown;				// array of ids of items shown - I don't think I need this
	
	function image_list() {
		$this->items = array();
		$this->items_string = "";
		$this->count = 0;
		$this->position = 0;
		$this->show_n = 10;
		$this->items_shown = array();
		$this->nav_command = "";
	}
	
	function set_defaults($input="") {
		if ($input == "") {
			$input = $this->items_string;
		}
		if (is_array($input)) {
			$this->items = $input;
		}
		else {
			$this->items = explode(",", $input);
		}
		$this->count = count($this->items);
		$this->items_string = implode(",", $this->items);
		
		return $this;
	}
	
	function get_items_shown($items="", $position="", $show_n="") {
		if ($items == "") {
			$items = $this->items;
		}
		if ($position == "") {
			$position = $this->position;
		}
		if ($show_n == "") {
			$show_n = $this->show_n;
		}

		$items_shown = array_slice($items, $position, $show_n);

		return $items_shown;
	}
	
	function print_list_header() {
		print("<table width=\"100%\" cellpadding=\"2\" cellspacing=\"1\">\n");
		print("	<tr>\n");
		print("		<td width=\"50%\">");
		if (count($this->items) > 0 && $this->items[0] != "") {
			print("Found ".$this->count." photo");
			if (count($this->items) > 1) {
				print("s");
			}
			print(", showing ");
			print($this->position + 1);
			print("-");
			$shown_end_n = ($this->position) + $this->show_n;
			if ($shown_end_n > $this->count) {
				$shown_end_n = $this->count;
			}
			print($shown_end_n);
			print(" of ");
			print($this->count);
			print(".");
		}
		else {
			$shown_end_n = 0;
			print("Found 0 photos, showing 0-0 of 0.");
		}
		print("		</td>\n");
		print("		<td align=\"right\">");
		
		if ($this->position != 0) {
			print("<a href=\"javascript:navigateList('first');\">First ".$this->show_n."</a>");
			print(" | ");
			print("<a href=\"javascript:navigateList('back');\">Previous</a>");
			print(" | ");
		}
		else {
			print("First | Previous | ");
		}
		if ($shown_end_n != $this->count) {
		print("<a href=\"javascript:navigateList('next');\">Next</a>");
		print(" | ");
		print("<a href=\"javascript:navigateList('last');\">Last ".$this->show_n."</a>");
		}
		else {
			print("Next | Last");
		}
		print("&nbsp;</td>\n");
		print("	</tr>\n");
		print("</table>\n");
	}
	
	function print_list($preview_type = "thumbnail") {
		if ($preview_type == "contact_sheet") {
			print_contact_sheet($this->items_shown, "id_list");
		}
		else {
			print("<table width=\"100%\" cellpadding=\"2\" cellspacing=\"1\">\n");
			print("	<tr class=\"rowHeader\">\n");
			print("		<td nowrap><b>Preview</b></td>\n");
			print("		<td nowrap><b>Details</b></td>\n");
			print("		<td nowrap><b>Keywords</b></td>\n");
			print("		<td nowrap><b>People</b></td>\n");
			print("		<td nowrap><b>Event</b></td>\n");
			print("		<td nowrap><b>Location</b></td>\n");
			print("		<td nowrap><b>Date</b></td>\n");
			print("		<td width=\"1%\"><img src=\"images/icon_indoors.gif\" height=\"16\" width=\"16\" alt=\"In/Outdoors\"></td>\n");
			print("		<td width=\"1%\"><img src=\"images/icon_portfolio.gif\" height=\"16\" width=\"16\" alt=\"Portfolio Shot\"></td>\n");
			print("		<td width=\"1%\"><img src=\"images/icon_details.gif\" height=\"16\" width=\"16\" alt=\"Add Details\"></td>\n");
			print("		<td width=\"1%\"><img src=\"images/icon_edit.gif\" height=\"16\" width=\"16\" alt=\"Edit\"></td>\n");
			print("	</tr>\n");
			if (empty($this->items[0])) {
				print("	<tr class=\"rowOdd\">\n");
				print("		<td colspan=\"10\">No photos to display.</td>\n");
				print("	</tr>\n");
			}
			else {
				for ($i = 0; $i < count($this->items_shown); $i++) {
					$temp_image = new image;
					$temp_image = $temp_image->retrieve($this->items_shown[$i]);
					$temp_image = $temp_image->convert_quotes_to_HTML();
	
					if (($i + 1) % 2 == 1) {
						print("	<tr class=\"rowOdd\" valign=\"top\">\n");
					} 
					else {
						print("	<tr class=\"rowEven\" valign=\"top\">\n");
					}
		
					if (!empty ($temp_image->thumbnail) && $preview_type == "thumbnail") {
						print("		<td align=\"center\"><a href=\"index.php?screen=view&id=".$temp_image->id."\"><img src=\"show_image_from_db.php?id=".$temp_image->id."\" class=\"onePixelBorder\"></a></td>\n");
					}
					else {
						print("		<td><a href=\"javascript:previewImage('".$temp_image->URL."',".$temp_image->orientation.");\">Preview</a></td>\n");
					}
					
					$last_slash_pos = strrpos($temp_image->URL, "/") + 1;
					$file_name = substr($temp_image->URL,$last_slash_pos);
					$title = trim_add_elipsis($temp_image->title, 200);
					$description = trim_add_elipsis($temp_image->description, 300);
	
					print("				<td>\n");
					print("					<table width=\"100%\" cellpadding=\"2\" cellspacing=\"0\">\n");
					print("						<tr valign=\"top\">\n");
					print("							<td width=\"1%\" align=\"right\"><b>Title:</b></td>\n");
					print("							<td colspan=\"3\"><a href=\"index.php?screen=view&id=".$temp_image->id."\">".$title."</a></td>\n");
					print("						</tr>\n");
					print("						<tr valign=\"top\">\n");
					print("							<td width=\"1%\" align=\"right\"><b>Desc:</b></td>\n");
					print("							<td colspan=\"3\">".$description."</td>\n");
					print("						</tr>\n");
					print("						<tr valign=\"top\">\n");
					print("							<td width=\"1%\" align=\"right\"><b>ID:</b></td>\n");
					print("							<td><a href=\"index.php?screen=view&id=".$temp_image->id."\">".$temp_image->id."</a></td>\n");
					print("							<td width=\"1%\" align=\"right\"><b>File:</b></td>\n");
					print("							<td><a href=\"index.php?screen=view&id=".$temp_image->id."\">".$file_name."</a></td>\n");
					print("						</tr>\n");
					print("					</table>\n");
					print("				</td>\n");
					print("				<td>".$temp_image->keywords."</td>\n");

					$people = trim_add_elipsis($temp_image->people, 100);

					print("				<td>".$people."</td>\n");
					print("				<td>".$temp_image->event."</td>\n");
					print("				<td>".$temp_image->location."<br>".$temp_image->state."&nbsp;&nbsp;".$temp_image->country."</td>\n");

					$dateentered = substr($temp_image->dateentered, 0, 4)."-".substr($temp_image->dateentered, 4, 2)."-".substr($temp_image->dateentered, 6, 2);

					print("				<td>\n");
					print("					<table width=\"100%\" cellpadding=\"2\" cellspacing=\"0\">\n");
					print("						<tr valign=\"top\">\n");
					print("							<td nowrap>\n");
					print("								Taken:<br>\n".$temp_image->datetaken."\n");
					print("							</td>\n");
					print("						</tr>\n");
					print("						<tr valign=\"top\">\n");
					print("							<td nowrap>\n");
					print("								Modified:<br>\n".$dateentered."\n");
					print("							</td>\n");
					print("						</tr>\n");
					print("					</table>\n");
					print("				</td>\n");
					
					if ($temp_image->indoors == "Indoors") {
						print("				<td><img src=\"images/icon_indoors.gif\" height=\"16\" width=\"16\" alt=\"Indoors\"></td>\n");
					}
					elseif ($temp_image->indoors == "Outdoors") {
						print("				<td><img src=\"images/icon_outdoors.gif\" height=\"16\" width=\"16\" alt=\"Outdoors\"></td>\n");
					}
					else {
						print("				<td></td>\n");
					}
					
					if ($temp_image->portfolio == 1) {
						print("				<td><img src=\"images/icon_portfolio.gif\" height=\"16\" width=\"16\" alt=\"Portfolio Shot\"></td>\n");
					}
					else {
						print("				<td></td>\n");
					}
					if ($temp_image->needdetails == 1) {
						print("				<td><a href=\"index.php?screen=entry&id=".$temp_image->id."\"><img src=\"images/icon_details.gif\" height=\"16\" width=\"16\" border=\"0\" alt=\"Add Details\"></a></td>\n");
					}
					else {
						print("				<td></td>\n");
					}
					print("				<td><a href=\"index.php?screen=entry&id=".$temp_image->id."\"><img src=\"images/icon_edit.gif\" height=\"16\" width=\"16\" border=\"0\" alt=\"Edit\"></a></td>\n");
					print("		</tr>\n");
				}
			}
			print("</table>");
		}
	}

	function navigate($nav_command) {
		switch ($nav_command) {
			case 'first':
				$this->position = 0;
				break;
			case 'back':
				$this->position = $this->position - $this->show_n;
				break;
			case 'next':
				$this->position = $this->position + $this->show_n;
				break;
			case 'last':
				$this->position = $this->count - $this->show_n;
				break;
			default:
				$this->position = 0;
		}
		return $this;
	}
}

class custom {

/*******************************************************************
	* class custom
	*
	* used to scope custom settings in the app
	*
	* Methods:
	*	custom() - initialize variables
	*
	*/

	var $entry_state;				// default state when entering photos
	var $entry_country;				// default country when entering photos
	var $load_folder_path;			// default path in add group folder path box
	var $delete_file;				// option to delete file from file system along with database record
	var $minimize_data_transfer;	// show smaller temp files instead of full size photo files
	var $date_taken_year_range;		// range of years available for $datetaken
	var $use_beta;					// notify of new beta version on about page
//	var $default_photographter;		// default entry for photo credit field
//	var $use_imagemagick;			// use imagemagick for image manipulations

	function custom() { // set defaults
		$this->entry_state = "";
		$this->entry_country = "";
		$this->load_folder_path = "gallery_photos/";
		$this->delete_file = 0;
		$this->minimize_data_transfer = 1;
		$this->datetaken_year_range = array(1997			// year from
                                           ,date('Y')		// year to
                                           );
        $this->use_beta = 0;
//		$this->default_photographer = "";
//		$this->use_imagemagick = 0;
	}
}

?>