<html>
<head>
<title>gallery - Configuration Test</title>
<link rel="stylesheet" href="main.css" type="text/css">
</head>
<body>

<p><b>Configuration Test</b>

<hr size="1" noshade>
<?

if (isset($_REQUEST["enabled"]) && $_REQUEST["enabled"] == 1) {
	$enabled = 1;
}
else {
	$enabled = 0;
}

if ($enabled == 1) {

	require('functions.php');
	$success = 0;
	
	$test = save_JPEG_file_from_JPEG('gallery_photos/photo.jpg');	
	
	print("<p><b>Attempting to Create Temp File</b>\n");
	if ($test != false) {
		print("<p>Temp photo successfully created.\n");
		print("<p><img src=\"temp/temp.jpg\" border=\"1\">\n");
		
		$success = $success + 1;
	}
	else {
		print("<p>Error: Could not create temp photo.\n");
		print("<p>Check that the temp folder is write-able and that the gd2 extension is enabled.\n");
	}
	
	print("<p>&nbsp;<p><b>Attempting to Read EXIF Data</b>\n");
	$test = read_exif_data_quick('gallery_photos/photo.jpg');
	if ($test != false) {
		print("<p>Successfully read EXIF data.<p>\n");
		$exif_data_rows = "";
		while(list($k,$v) = each($test)) {
			if ($k != "Thumbnail") {
				$exif_data_rows = $exif_data_rows."<tr valign=\"top\">\n"."\t<td width=\"1%\" align=\"right\" nowrap>$k</td>\n"."\t<td>$v</td>\n"."</tr>\n";
			}
		}
		print("<table width=\"100%\" cellpadding=\"0\" cellspacing=\"7\">\n");
		print($exif_data_rows);
		print("</table>\n");
		
		$success = $success + 1;
	}
	else {
		print("<p>Error: Could not read EXIF data.\n");
		print("<p>Check that the exif extension is enabled.\n");
	}

	if ($success == 2) {
		print("<p><b>Both tests passed</b>, go to <a href=\"index.php\">gallery</a>.");
	}
}
else {
	print("<p>This will try to read the EXIF data from the temp file and create a thumbnail from the test photo; saving it as a temp file.\n<p>If this succeeds, then the permissions on the 'temp' folder are correct and the <br> 'exif' and 'gd2' extensions are enabled.\n");
	print("<p><a href=\"run_me_first.php?enabled=1\">Run the test</a>\n");
}
?>

</body>
</html>
