<? 

$debug = 0;

// set database connection
require ("database.php"); 

// define objects
require ("objects.php");

// functions
require ("functions.php");

// ---------------------------------------------------------------------------
// get image and spit out data

if ($debug == 1) {
	print_r(array_keys($_REQUEST));
	print_r(array_values($_REQUEST));
}

if (isset($_REQUEST["id"])) {
	$id = $_REQUEST["id"];
}

if (isset($_REQUEST["action"])) {
	$action = $_REQUEST["action"];
}

$image_entry = new image;

if (!empty($id)) {
	$image_entry = $image_entry->retrieve($id);
}
else {
	$msg_error = "<b>Error:</b> No photo ID was specified.</span>\n";
	$image_entry->id = "None Specified";
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>Save a Copy of Photo #<? echo $image_entry->id; ?></title>
	<link rel="stylesheet" type="text/css" href="main.css">
</head>
<body>

<div class="groupBorder">
	<div class="groupHeader">Save a Copy of Photo #<? echo $image_entry->id; ?></div>
<? 
if (isset($msg_error) && !empty($msg_error)) {
	print($msg_error);
}
elseif (isset($action) && $action == "save_copy") {
	if (isset($_REQUEST["pixel_size"])) {
		$pixel_size = $_REQUEST["pixel_size"];
		if ($pixel_size > 3000) {
			$pixel_size = 3000;
		}
	}
	else {
		$pixel_size = 640;
	}
	if (isset($_REQUEST["file_name"])) {
		$file_name = $_REQUEST["file_name"];
	}
	else {
		$file_name = "copy_of_photo_".$image_entry->id;
	}
	if (isset($_REQUEST["quality"])) {
		$quality = $_REQUEST["quality"];
	}
	else {
		$quality = 70;
	}
	
	$new_file = save_JPEG_file_from_JPEG($image_entry->URL, $pixel_size, "saved_copies/", $file_name, $quality);

	if ($new_file != false) {
?>
	<table width="100%" cellpadding="0" cellspacing="7">
		<tr valign="top">
			<td>
				<p>Successfully created copy of photo #<? echo $image_entry->id; ?>.
				<p>View: <a href="<? print($new_file); ?>" target="_blank" onclick="window.close()"><? print($new_file); ?></a>
			</td>
		</tr>
	</table>
<?
	}
}
else {
?>
	<table width="100%" cellpadding="0" cellspacing="7">
	<form name="imageForm" method="post" action="save_a_copy.php">
		<tr valign="top">
			<td>
				New File Name:
				<input type="text" name="file_name" value="copy_of_photo_<? echo $image_entry->id; ?>" style="width: 100%;" class="onePixelBorder">
			</td>
			<td rowspan="8" width="1%"><img src="show_image_from_db.php?id=<? echo $image_entry->id; ?>" class="onePixelBorder"></td>
		</tr>
		<tr valign="top">
			<td>Do NOT include the ".jpg" file extension.</td>
		</tr>
		<tr valign="top">
			<td class="trHR"><img src="images/clear.gif" height="1" width="1"></td>
		</tr>
		<tr valign="top">
			<td>
				Quality:
				<select name="quality" class="onePixelBorder">
					<option value="100">Highest</option>
					<option value="80" selected>High</option>
					<option value="60">Medium</option>
					<option value="40">Low</option>
					<option value="20">Lowest</option>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<td>Higher quality results in a larger file size.</td>
		</tr>
		<tr valign="top">
			<td class="trHR"><img src="images/clear.gif" height="1" width="1"></td>
		</tr>
		<tr valign="top">
			<td>Size (in pixels) of Longest Edge: <input type="text" name="pixel_size" value="640" style="width: 50px;" class="onePixelBorder"></td>
		</tr>
		<tr valign="top">
			<td>
				Standard Sizes:
				<ul>
					<li>90 (Small Thumbnail)
					<li>160 (Thumbnail)
					<li>320 (Digital 3x5)
					<li>640 (Digital 4x6)
					<li>800 (Digital 8x10)
				</ul>
				For anything larger or for making physical prints, you are better off using an image editing program like Adobe Photoshop.
				<br>&nbsp;
			</td>
		</tr>
		<tr valign="top">
			<td colspan="2"><input type="submit" name="submit" value="Create New Photo"></td>
		</tr>
	<input type="hidden" name="id" value="<? echo $image_entry->id; ?>">
	<input type="hidden" name="action" value="save_copy">
	</form>
	</table>
</div>

<? 
}
mysql_close($link); 
?>

</body>
</html>

